# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyApplication/EasyApplicationObject.py,v 1.1 2004/06/28 10:04:07 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__='''EasyApplication'''
__version__='$Revision: 1.1 $'[11:-2]

import Globals

from Globals import DTMLFile
from AccessControl import ClassSecurityInfo
from OFS.Folder import Folder
from Products.EasyNavigation.VirtualPath import VirtualPathBase
from Products.EasyApplication.EasyApplicationConf import *


class EasyApplicationObject(Folder, VirtualPathBase):
    """Web application object class"""

    security = ClassSecurityInfo()

    meta_type = 'EasyApplicationObject'


Globals.InitializeClass(EasyApplicationObject)

manage_addEasyApplicationObjectForm = DTMLFile('dtml/manage_addEasyApplicationObjectForm', globals())

def manage_addEasyApplicationObject(self, id=None, title='', REQUEST=None):
    """Add a EasyApplication object"""

    if not id: id=self.subclass
    ob=EasyApplicationObject(id, title)
    self._setObject(id, ob)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


def initialize(context):
    """Initialize StyleManagers Product"""

    context.registerClass(
        EasyApplicationObject,
        permission=EasyApplicationObjectAdd,
        icon='icons/EasyApplicationObject.gif',
        constructors = ( manage_addEasyApplicationObjectForm, manage_addEasyApplicationObject ),
        meta_type = 'EasyApplicationObject',
        visibility = None,
    )



