# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyApplication/EasyCSVSupport.py,v 1.2 2004/07/01 10:46:35 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """\
EasyCSVSupport
"""
__version__='$Revision: 1.2 $'[11:-2]


import Globals
from Acquisition import aq_inner
from Globals import DTMLFile
from urllib import quote
from types import StringType
from AccessControl import ClassSecurityInfo

##EasyApplication
from Products.EasyApplication.EasySecurityConf import EasyApplicationObjectView

import os
DEBUG_MODE = os.environ.get('Z_DEBUG_MODE','')


from Products.EasyCore import MLOG_TAB, C_MLOG_TAB

#from App.version_txt import getZopeVersion
#zope_version=getZopeVersion()


class EasyCSVSupport:

    #Energy+ hack for CSV

    manage_options= ( {'label': 'Export', 'action': 'manage_csv',},)

    security = ClassSecurityInfo()

    security.declareProtected(EasyApplicationObjectView, 'manage_csv')
    manage_csv=DTMLFile('dtml/energy_plus/manage_csv', globals())

    EasyApplicationObjectView
    security.declareProtected(EasyApplicationObjectView, 'manage_show_csv', 'manage_show_csv.csv', 'manage_show_csv.xls')
    def manage_show_csv(self, REQUEST=None, RESPONSE=None, as_text=0, debug=0, content_type='application/csv'):
        """ttw"""
        columns=(
            {'label':"WorkflowState", 'variable':'getWorkflowState', 'expr':'value', 'quote':1},
            {'label':"Model reference", 'variable':'model_reference','expr':'value', 'quote':1},
            {'label':"Manufacturer", 'variable':'manufacturer','expr':'value', 'quote':1},
            {'label':"Brand", 'variable':'brand_name','expr':'value', 'quote':1},
            {'label':"EU Category", 'variable':'EU_category','expr':'value', 'quote':1},
            {'label':"Visible Category", 'variable':'visible_category','expr':'value', 'quote':1},
            {'label':"Freezer position", 'variable':'freezer_mounting','expr':'value', 'quote':1},
            {'label':"Available in", 'variable':'available_from', 'expr':'value', 'quote':1},
            {'label':"Frost Free", 'variable':'frost_free', 'expr':"value and 'Yes' or 'No'", 'quote':0},
            {'label':"Compressors", 'variable':'number_of_compressors','expr':'value', 'quote':0},
            {'label':"Climate Class", 'variable':'climate_class', 'expr':"' '.join(value)", 'quote':1},
            {'label':"EEI", 'variable':'EEI','expr':'value', 'quote':0},
            {'label':"Width", 'variable':'width','expr':'value', 'quote':0},
            {'label':"Height", 'variable':'height','expr':'value', 'quote':0},
            {'label':"Depth", 'variable':'depth','expr':'value', 'quote':0},
            {'label':"Built in", 'variable':'built_in_appliance','expr':"value and 'Yes' or 'No'", 'quote':0},
            {'label':"Fresh Food Volume", 'variable':'fresh_volume','expr':'value', 'quote':0},
            {'label':"Frozen Food Volume", 'variable':'frozen_volume','expr':'value', 'quote':0},
            {'label':"Energy cons kWh/Year", 'variable':'energy_consumption','expr':'value', 'quote':0},
            {'label':"Foaming agent", 'variable':'foaming_agent','expr':'value', 'quote':1},
            {'label':"Quantity", 'variable':'foaming_agent_quantity','expr':'value', 'quote':0},
            {'label':"Refrigerant", 'variable':'refrigerant','expr':'value', 'quote':1},
            {'label':"Quantity", 'variable':'refrigerant_quantity','expr':'value', 'quote':0},
            {'label':"Availability", 'variable':'available_countries','expr':"' '.join(value)", 'quote':1},
            {'label':"Noise level", 'variable':'noise_level','expr':'value', 'quote':0},
            {'label':"External freezer temp display", 'variable':'external_freezer_display','expr':"value and 'Yes' or 'No'", 'quote':0},
            {'label':"Is Master", 'variable':'master_appliance','expr':"value and 'Yes' or 'No'", 'quote':0},
            {'label':"Test Report", 'variable':'test_report','expr':"value and 'Yes' or 'No'", 'quote':0},
            {'label':"Photograph Provided", 'variable':'photograph_provided','expr':"value and 'Yes' or 'No'", 'quote':0},
            {'label':"Comments", 'variable':'comments', 'expr':r"value.replace('\n', ' ')", 'quote':1},
          )

        if debug:
            columns = columns + (
                {'label':"physicalURL", 'variable':'physicalURL', 'expr':'value', 'quote':1},
                {'label':"Language", 'variable':'getCurrentLanguage','expr':'value', 'quote':1},
                {'label':"rid", 'variable':'data_record_id_', 'expr':'value', 'quote':1},
            )

        results=self.getSubObjectsByClass('product', lanugage='en')
        csv_file=[]
        for record in results:
            csv_file.append(render_row(make_csv_row(record, columns)))

        if as_text:
            RESPONSE.setHeader('content-type', 'text/plain')
        else:
            RESPONSE.setHeader('content-type', content_type)
        return "%s\n%s" % (render_row(make_csv_header(columns)), '\n'.join(csv_file))

Globals.InitializeClass(EasyCSVSupport)


setattr(EasyCSVSupport, 'manage_show_csv.csv', EasyCSVSupport.manage_show_csv)
setattr(EasyCSVSupport, 'manage_show_csv.xls', EasyCSVSupport.manage_show_csv)

def render_row(row_tuple):
    return ';'.join(map(lambda x: str(x), row_tuple))

def make_csv_header(columns, quote_char='"'):
    result=[]
    i=0
    for column in columns:
        i=i+1
        result.append("%s%s%s" % (quote_char, column.get('label', 'Column%s' % str(i) ), quote_char) )
    return tuple(result)

def make_csv_row(record, columns, quote_char='"'):
    result=[]
    for column in columns:
        id=column.get('variable', None)
        expr=column.get('expr', 'value')
        if id is not None:
            value=getattr(record, id, None)
            try: value=eval(expr, {'value':value }, {})
            except: pass
            if column.get('quote', 0):
                value='%s%s%s' % (quote_char, value, quote_char)
            result.append(value)
    return tuple(result)
