# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/BodyTabs.py,v 1.5 2004/09/15 14:02:40 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#


__doc__ = """\
BodyTabs patches tabs support for the page_body.
"""
__version__ = '1.8'


import Globals
from types import DictType
from Globals import DTMLFile, HTML, InitializeClass
from AccessControl import ClassSecurityInfo
from AccessControl import getSecurityManager, Unauthorized
import ExtensionClass
from App.Management import Navigation, Tabs
from ExtensionClass import Base
from Utils.DebugUtils import MLOG_TAB, C_MLOG_TAB



_marker=[]

_manage_body_tab=HTML("""\
<div id="body_tab">
<table cellpadding="0" cellspacing="0" border="0" width="100%">
<dtml-if rendered_tabs>
<tr><td style="width:18px;border-width:0px 0px 2px 0px;border-color:#000;border-style:solid;"><img src="<dtml-var "REQUEST['BASEPATH1']">/misc_/EasyPresentationHelpers/space.gif" alt="" width="18"></td>
<dtml-var rendered_tabs>
</dtml-if rendered_tabs>
<td style="width:100%;border-width:0px 0px 2px 0px;border-color:#000;border-style:solid;"><img src="<dtml-var "REQUEST['BASEPATH1']">/misc_/EasyPresentationHelpers/space.gif" alt=""></td>
</tr></table>
</div>
""", globals())

_manage_page_body="""<div id="page_body">""" #HTML("""<div id="page_body">""", globals())


_manage_selectable_body_tab=HTML("""\
<dtml-if "url and label">
<td style="color:#&dtml-textColor;;background-color:#&dtml-backgroundColor;;margin:0px;border-top:2px solid #&dtml-borderColor;;border-right:2px solid #&dtml-borderRightColor;;border-bottom:2px solid #&dtml-borderBottomColor;;border-left:&dtml-borderLeftWidth;px solid #&dtml-borderColor;;padding:0px 6px 2px 6px;font-family:verdana;font-size:10px;font-weight:bold;"><a href="&dtml-url;" style="color:#&dtml-textColor;;"><nobr><dtml-var label></nobr></a></td>
</dtml-if "url and label">
""", globals())

_manage_unselectable_body_tab=HTML("""\
<dtml-if "url and label">
<td style="color:#&dtml-textColor;;background-color:#&dtml-backgroundColor;;margin:0px;border-top:2px solid #&dtml-borderColor;;border-right:2px solid #&dtml-borderRightColor;;border-bottom:2px solid #&dtml-borderBottomColor;;border-left:&dtml-borderLeftWidth;px solid #&dtml-borderColor;;padding:0px 6px 2px 6px;font-family:verdana;font-size:10px;font-weight:bold;"><nobr><dtml-var label></nobr></td>
</dtml-if "url and label">
""", globals())



class BodyTabs(ExtensionClass.Base):

    security = ClassSecurityInfo()
    security.declareProtected('View management screens', 'manage_body_tab')
    def manage_body_tab(self, client=None, REQUEST=None
                        , body_tab_id='body_tab'
                        , management_view_id='management_view'
                        , SELECTABLE_BODY_TAB=_manage_selectable_body_tab
                        , UNSELECTABLE_BODY_TAB=_manage_unselectable_body_tab
                        , MANAGE_BODY_TAB=_manage_body_tab
                        ):
        """ttw"""
        try: current_tab=REQUEST[body_tab_id]
        except: current_tab=None
        try: management_view=REQUEST[management_view_id]
        except: management_view=None

        rendered_tabs=''

        inherited_body_tabs=[]
        body_tabs_for_view=None
        getInheritedBodyTabs(self.__class__,inherited_body_tabs.append)
        inherited_body_tabs.reverse()
        for bts in inherited_body_tabs:
            if bts.has_key(management_view):
                body_tabs_for_view=bts.get(management_view)
                break

        if callable(body_tabs_for_view): body_tabs_for_view=body_tabs_for_view(self
                                                                , client=client, REQUEST=REQUEST
                                                                , body_tab_id=body_tab_id
                                                                , management_view_id=management_view_id)

        if body_tabs_for_view:
            validate=getSecurityManager().validate
            if current_tab and body_tabs_for_view:
                bodytabs=''
                borderLeftWidth=2
                borderRightColor=''
                base_path=self.getPhysicalPath()
                number_of_body_tabs=len(body_tabs_for_view)
                for index in range(number_of_body_tabs):
                    body_tab=body_tabs_for_view[index]
                    if index<number_of_body_tabs-1:
                        next_is_current=body_tabs_for_view[index+1].get('label', '')==current_tab.get('label', '')
                    else: next_is_current=0
                    url=body_tab.get('url', None)
                    path=base_path+(url,)
                    o=self.unrestrictedTraverse(path, None)
                    if o is None: continue
                    try:
                        if not validate(None, self, None, o):
                            continue
                    except:
                        if hasattr(o, '__roles__'):
                            continue
                    is_current=body_tab.get('label', '')==current_tab.get('label', '')
                    borderRightColor=(is_current or next_is_current)and '000' or '333'
                    if body_tab.get('selectable',1):
                        if is_current:
                            rendered_tabs = rendered_tabs + SELECTABLE_BODY_TAB( REQUEST=REQUEST
                                                                  , label=body_tab['label']
                                                                  , url=body_tab['url']
                                                                  , textColor='000'
                                                                  , borderColor='000'
                                                                  , backgroundColor='eee'
                                                                  , borderBottomColor='eee'
                                                                  , borderLeftWidth=borderLeftWidth
                                                                  , borderRightColor=borderRightColor
                                                                )
                        else:
                            rendered_tabs = rendered_tabs + SELECTABLE_BODY_TAB(REQUEST=REQUEST
                                                                  , label=body_tab['label']
                                                                  , url=body_tab['url']
                                                                  , textColor='fff'
                                                                  , backgroundColor='666'
                                                                  , borderColor='333'
                                                                  , borderBottomColor='000'
                                                                  , borderLeftWidth=borderLeftWidth
                                                                  , borderRightColor=borderRightColor
                                                                )
                    else:
                        if is_current:
                            rendered_tabs = rendered_tabs + UNSELECTABLE_BODY_TAB( REQUEST=REQUEST
                                                                  , label=body_tab['label']
                                                                  , url=body_tab['url']
                                                                  , textColor='000'
                                                                  , backgroundColor='eee'
                                                                  , borderColor='000'
                                                                  , borderBottomColor='eee'
                                                                  , borderLeftWidth=borderLeftWidth
                                                                  , borderRightColor=borderRightColor
                                                                )
                        else:
                            rendered_tabs = rendered_tabs + UNSELECTABLE_BODY_TAB(REQUEST=REQUEST
                                                                  , label=body_tab['label']
                                                                  , url=body_tab['url']
                                                                  , textColor='999'
                                                                  , backgroundColor='666'
                                                                  , borderColor='333'
                                                                  , borderBottomColor='000'
                                                                  , borderLeftWidth=borderLeftWidth
                                                                  , borderRightColor=borderRightColor
                                                                )
                    borderLeftWidth=0

        return MANAGE_BODY_TAB(rendered_tabs=rendered_tabs, REQUEST=REQUEST)


    security.declareProtected('View management screens', 'manage_page_body')
    def manage_page_body(self, client=None, REQUEST=None
                        , body_tab_id='body_tab'
                        , management_view_id='management_view'
                        ):
        """ttw"""
        return self.manage_body_tab(client=client, REQUEST=REQUEST
                    , body_tab_id=body_tab_id
                    , management_view_id=management_view_id)+ _manage_page_body

    security.declareProtected('View management screens', 'manage_show_body_tabs')
    def manage_show_body_tabs(self, client=None, REQUEST=None):
        """ttw"""
        inherited_body_tabs=[]
        body_tabs_for_view=None
        getInheritedBodyTabs(self.__class__,inherited_body_tabs.append)
        inherited_body_tabs.reverse()
        return inherited_body_tabs


InitializeClass(BodyTabs)



class BodyTabsInfo:
    """Encapsulate BodyTabs information."""

    __bodytabs_info__ = 1

    __roles__ = ()

    def __init__(self):
        self.bodytabs = {}

    def declareBodyTab(self
                    , url=None
                    , management_view=None
                    , order=None
                    , label=None
                    , selectable=None
                    , body_tab_id='body_tab'
                    , management_view_id='management_view'
                    ):
        body_tab={}
        body_tab[management_view_id]=management_view
        body_tab['order']=order
        body_tab['label']=label
        body_tab['url']=url
        body_tab['selectable']=selectable or 1
        self.bodytabs[body_tab_id]=body_tab



def getInheritedBodyTabs(class_instance, append, body_tabs_id='_body_tabs'):
    """\
    Finds all vaiables named [body_tabs_name] in the class hierarcy.

    """
    for base_class in class_instance.__bases__:
        getInheritedBodyTabs(base_class, append, body_tabs_id=body_tabs_id)
    if class_instance.__dict__.has_key(body_tabs_id):
        append(class_instance.__dict__.get(body_tabs_id))


def getInheritedBodyTab(class_instance, inherited_dict, body_tab_id='body_tab'):
    """\
    Finds all class attributes that has an attribute name [body_tab_id].

    """
    for base_class in class_instance.__bases__:
        getInheritedBodyTab(base_class, inherited_dict)
    #add revers to make entries higher up override earlier entries
    for key, value in class_instance.__dict__.items():
        if getattr(value, 'globals', {}).has_key(body_tab_id):
            inherited_dict[key]=value
        elif getattr(value, '__bodytabs_info__', 0):
            bodytabs=getattr(value, 'bodytabs', None)
            if bodytabs: inherited_dict[key]=bodytabs


def body_tab__class_init__(self, body_tab_id='body_tab', management_view_id='management_view'):
    dict=self.__dict__
    body_tabs={}
    inherited_dict={}
    getInheritedBodyTab(self, inherited_dict, body_tab_id=body_tab_id)

    tab_order={}
    inherited_items=inherited_dict.items()
    for temp_name, v in inherited_items:
        if type(v)==DictType:
            globals=v
        else:
            globals=getattr(v, 'globals', None)
        if globals:
            body_tab=globals.get(body_tab_id, None)
            if body_tab:
                management_view=body_tab.get(management_view_id, None)
                if not management_view:
                    management_view=globals.get(management_view_id, None)
                if management_view:
                    order = body_tab.get('order', '')
                    if order>0:
                        tab_order_for_view=tab_order.get(management_view, {})
                        label_for_order=tab_order_for_view.get(order, [])
                        body_tab['url']=body_tab.get('url',temp_name)
                        label_for_order.append(body_tab)
                        tab_order_for_view[order]=label_for_order
                        tab_order[management_view]=tab_order_for_view

    for mview, tab_order_for_view in tab_order.items():
        #normalize order
        new_order={}
        order = 1
        ordered_list=tab_order_for_view.keys()
        ordered_list.sort()
        for index in ordered_list:
            for entry in tab_order_for_view[index]:
                new_order[order]=entry
                order=order+1
        body_tabs_for_view=body_tabs.get(mview, ())
        #Add Inherited
        ordered_list=new_order.keys()
        ordered_list.sort()
        user_labels=[]
        for key in ordered_list:
            entry=new_order[key]
            if entry['label'] not in user_labels: #No duplicate labels, use first found
                body_tabs_for_view=body_tabs_for_view+(entry,)
            user_labels.append(entry['label'])
        body_tabs[mview]=body_tabs_for_view

    if body_tabs:
        dict['_body_tabs']=body_tabs


InitializeBodyTabs=body_tab__class_init__



def UpdateTab(self
                , order=None
                , url=None
                , label=None
                , selectable=None
                , management_view=None
                , body_tab_id='body_tab'
                , management_view_id='management_view'
                ):
    globals=getattr(self, 'globals', _marker)
    if globals is _marker:
        #Can't set attributes on methods (but function works fine :-)
        setattr(self.im_func, 'globals', {})
        globals=getattr(self, 'globals')
    if type(globals)==DictType:
        body_tab=globals.get(body_tab_id, None)
        if type(body_tab)!=DictType:
            globals[body_tab_id]={}
            body_tab=globals.get(body_tab_id)
        if order:
            body_tab['order']=order
        if label:
            body_tab['label']=label
        if url:
            body_tab['url']=url
        if selectable:
            body_tab['selectable']=selectable
        if management_view:
            body_tab[management_view_id]=management_view
            globals[management_view_id]=management_view


