# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/EasyManagmentTabs.py,v 1.1 2004/06/28 10:04:10 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """EasyManagmentTabs
See README.txt for more details."""
__version__='$Revision: 1.1 $'[11:-2]



import Globals
from string import split
from App.Management import Tabs
from AccessControl import getSecurityManager
from Globals import HTML, DTMLFile
from AccessControl import ClassSecurityInfo
from MultiMapping import MultiMapping
from types import TupleType, StringType
_marker=[]

TEMPLATE_CONFIG_DEFAULT = {

    'color': '#000',
    'background': '#fff',
    'width': '',
    'height': '',

    'active_color': '#666',
    'passiv_color': '#999',

    'active_color_above': '#666',
    'passiv_color_above': '#999',
    'height_above': '1px',

    'active_color_bellow': '#666',
    'passiv_color_bellow': '#999',
    'height_bellow': '1px',

    'active_link_color': '#FFF',
    'passiv_link_color': '#000',

    'border_color': '#000',
    'border_size': '0px 0px 0px 0px',
    'border_style': 'solid',

    'padding': '0px 0px 0px 0px',
    'margin': '0px 0px 0px 0px',

    'always_show_message':0,
}


outer_div = HTML("""\
<dtml-with styles mapping>
<div style="
    margin:&dtml-margin;;
    padding:&dtml-padding;;
    border-width:&dtml-border_size;;
    border-style:&dtml-border_style;;
    border-color:&dtml-border_color;;"
    ><dtml-var result></div></dtml-with>"""
    , globals())


def createManageIndex( manage_options
                     , template=None
                     , styles=None
                     , tabs_index=None
                     , tabs_lookup=None
                     , lpath=None
                     , rows=None
                     , locals=locals()
                     ):
    if type(manage_options) == StringType:
        manage_options = locals.get(manage_options, ())
    #Untested
    if callable(manage_options): manage_options=manage_options()
    if tabs_index is None: tabs_index={}
    if tabs_lookup is None: tabs_lookup={}
    if lpath is None: lpath=()
    if rows is None: rows=[(manage_options, template, styles)]
    for option in manage_options:
        action=option.get('action', None)
        label=option.get('label', None)

        submenu=option.get('submenu', None)
        if type(submenu) == StringType:
            submenu = locals.get(submenu, None)
        #Untested
        if callable(submenu): submenu=submenu()
        current_template=option.get('template', None)
        current_styles=option.get('styles', None)

        if label and action:
            if submenu is not None:
                rows.append((submenu, current_template, current_styles))
            newlpath = lpath + (label,)
            if not tabs_index.has_key(newlpath):
                tabs_index[newlpath] = list(rows)
            if not tabs_lookup.has_key(action):
                tabs_lookup[action] = (newlpath, option, template, styles)
            if submenu is not None:
                tabs_index, tabs_lookup = createManageIndex(
                                              submenu
                                            , template=current_template
                                            , styles=current_styles
                                            , tabs_index=tabs_index
                                            , tabs_lookup=tabs_lookup
                                            , lpath=newlpath
                                            , rows=rows
                                            , locals=locals)
                rows.pop()
    return tabs_index, tabs_lookup


class ManagementTabs:

    def __init__(self): pass

class ManagementTabsInfo:

    def __init__(self): pass
        #self.tabs_index={}
        #self.tabs_lookup={}

    def addMenu(self):pass


class EasyManagmentTabs(Tabs):
    """EasyManagmentTabs object."""

    security = ClassSecurityInfo()
    manage_options = ()

    tabs_index, tabs_lookup = createManageIndex(manage_options, locals=locals())

    security.declarePublic('manage_tabs_default')
    manage_tabs_default = DTMLFile('dtml/manage_tabs_default', globals())

    security.declarePublic('manage_tabs_finish')
    manage_tabs_finish = DTMLFile('dtml/manage_tabs_finish', globals())

    security.declarePublic('manage_tabs_submenu')
    manage_tabs_submenu = DTMLFile('dtml/manage_tabs_submenu', globals())

    security.declarePublic('filtered_manage_options')
    def filtered_manage_options(self, REQUEST=None, manage_options=None):
        if manage_options is None: manage_options = self.manage_options
        validate=getSecurityManager().validate
        result=[]
        if callable(manage_options): manage_options=manage_options()
        options=tuple(manage_options)
        for d in options:
            filter=d.get('filter', None)
            if filter is not None and not filter(self):
                continue
            path=d.get('path', None)
            if path is None: path=d['action']
            o=self.unrestrictedTraverse(path, None)
            if o is None: continue
            try:
                if validate(None, self, None, o):
                    result.append(d)
            except:
                if not hasattr(o, '__roles__'):
                    result.append(d)
        return result

    def setupTemplateConfiguration(self, styles={}, extra={}, REQUEST={}):
        if REQUEST is None: REQUEST=self.REQUEST
        multimapping=MultiMapping()
        multimapping.push(TEMPLATE_CONFIG_DEFAULT)
        multimapping.push(styles)
        multimapping.push(REQUEST)
        multimapping.push(extra)
        return multimapping

    security.declarePublic('manage_tabs')
    def manage_tabs( self
                   , active_tabs=None
                   , start=0
                   , stop=None
                   , show_message=1
                   , label=''
                   , REQUEST=None
                   , index='tabs_index'
                   , lookup='tabs_lookup'
                   , template=None
                   , styles=None
                   , outer_styles=None
                   , **kw):
        if REQUEST is None: REQUEST=self.REQUEST
        management_view=REQUEST.get('management_view',None)
        method = split(REQUEST.get('URL'),'/')[-1:][0]
        #Get current pages menu info
        tabs_lookup=getattr(self, lookup, getattr(self, 'tabs_lookup', None))
        if tabs_lookup is not None:
            current_tab=tabs_lookup.get(method, None)
            if current_tab is not None:
                template=current_tab[2] or template
                styles=current_tab[3] or styles
        else: current_tab=None

        #If active_tabs (a tuple of Labels of the current menus) is not defined
        if type(template)==StringType:
            template=getattr(self, template, None)
        if type(styles)==StringType:
            styles=getattr(self, styles, None)
        if type(outer_styles)==StringType:
            outer_styles=getattr(self, outer_styles, None)

        if active_tabs is None:
            if current_tab:
                active_tabs=current_tab[0]
            else:
                active_tabs=(management_view,)

        tabs_index= getattr(self, index, getattr(self, 'tabs_index', None))
        if tabs_index is None or not tabs_index.has_key(active_tabs):
            if template is None:
                return Tabs.manage_tabs(self, REQUEST=REQUEST)
            else:
                styles=self.setupTemplateConfiguration(REQUEST=REQUEST, styles=styles, extra=kw)
                return template(options=submenu
                              , management_view=management_view
                              , method=method
                              , active_tabs=active_tabs
                              , label=label
                              , start=start
                              , stop=stop
                              , styles=styles
                              , REQUEST=REQUEST)

        tab_rows=tabs_index.get(active_tabs, None)

        #Setup
        result=''
        if stop is None: stop=len(tab_rows)
        counter=0
        styles=self.setupTemplateConfiguration(REQUEST=REQUEST, styles=styles, extra=kw)
        for submenu, local_template, local_styles in tab_rows[start:stop]:
            local_template = getattr(self, local_template, self.manage_tabs_default)
            local_styles = getattr(self, local_styles, styles)
            local_styles=self.setupTemplateConfiguration(styles=local_styles, REQUEST=REQUEST, extra=kw)
            if callable(submenu): submenu=submenu()
            submenu=self.filtered_manage_options(manage_options=submenu)
            result=result+local_template( options=submenu
                                  , management_view=management_view
                                  , method=method
                                  , active_tabs=active_tabs
                                  , label=label
                                  , counter=counter+start
                                  , tab_width=len(submenu)
                                  , start=start
                                  , stop=stop
                                  , current=active_tabs[min(len(active_tabs)-1,counter+start)]
                                  , styles=local_styles
                                  , REQUEST=REQUEST)
            label=''
            counter=counter+1

        if outer_styles is not None:
            outer_styles=self.setupTemplateConfiguration(REQUEST=REQUEST, styles=outer_styles)
            result=outer_div(result=result, styles=outer_styles, REQUEST=REQUEST)

        if show_message and current_tab:
            active_tabs, option, template, styles=current_tab
            template = getattr(self, str(template)+'_finish', self.manage_tabs_finish)
            #NO USED (YET) styles = getattr(self, styles, {})
            styles=self.setupTemplateConfiguration(REQUEST=REQUEST, styles=styles,extra=kw)
            result=result+template( option=option
                                  , active_tabs=active_tabs
                                  , styles=styles
                                  , REQUEST=REQUEST)
        return result

Globals.InitializeClass(EasyManagmentTabs)


