# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyCore/LinkAssessments.py,v 1.1 2004/06/28 10:04:10 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""LinkAssessments"""
__version__='$Revision: 1.1 $'[11:-2]

from ExtensionClass import Base

from interfaces.EasyObjectLink import LinkAssessment


class LinkAssessmentBase(Base):
    __implements__ = (LinkAssessment, )
    code=0
    operation = "Operation"
    reason="""No explanaition available."""


#Link Creation Assessments
class LinkCreationDenied(LinkAssessmentBase):
    code=100
    operation = "Creation"

class MultipleLinksNotAllowed(LinkCreationDenied):
    code=101
    reason="""Multiple links not allowed"""


#Link Destruction Assessments
class LinkDestructionDenied(LinkAssessmentBase):
    code=200
    operation = "Destruction"

class ZeroLinkNotAllowed(LinkDestructionDenied):
    code=201
    reason="""At least one link is required."""

#Link Remove
class LinkRemoved(LinkAssessmentBase):
    code=300
    operation = "Removed"

class LinkRemovedOnInvalidRemoteLink(LinkRemoved):
    code=301
    reason="""The remove link was invalid."""

#Link Unchanged
class LinkUnchanged(LinkAssessmentBase):
    code=400
    operation = "Unchanged"



