# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/EasyPublisher.py,v 1.4 2004/09/28 10:04:50 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#
__version__='$Revision: 1.4 $'[11:-2]
__doc__='''EasyEditable product: EasyPublisher base class.'''


import Globals
from ExtensionClass import Base
from Products.EasyCore.EasyResourcesConf import RESOURCE_CATALOG_ID
from Products.EasyCore.EasyNavigationConf import NAVIGATION_CATALOG_ID
from Products.EasyCore.EasyNewsServiceConf import NEWS_SERVICE_ID
from Products.EasyCore.EasySearchServiceConf import SEARCH_SERVICE_ID
#from Products.EasyCore.EasyCalenderConf import CALENDER_CATALOG_ID
from Products.EasyCore.EasyEditorConf import EASYEDITORID
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions
from Acquisition import aq_inner, aq_parent
from ComputedAttribute import ComputedAttribute


class EasyPublisherBase(Base):

    security = ClassSecurityInfo()

    #Service API

    security.declarePublic('getEasyNavigation')
    def getEasyNavigation(self, marker=None):
        return getattr(self,NAVIGATION_CATALOG_ID, None)

    security.declarePublic('getEasyNavigationURL')
    def getEasyNavigationURL(self):
        #Deprecated use getEasyNavigation.physicalURL instead
        raise "getEasyNavigationURL has been deprecated use getEasyNavigation.physicalURL instead."
        nc = getattr(self,NAVIGATION_CATALOG_ID, None)
        if nc!=None:
            return nc.physicalURL
        raise "ServiceError", "Can't locate %s" % NAVIGATION_CATALOG_ID

    security.declarePublic('getEasyNavigationPath')
    def getEasyNavigationPath(self):
        #Deprecated use getEasyNavigation.physicalPath instead
        raise "getEasyNavigationPath has been deprecated use getEasyNavigation.physicalPath instead."
        nc = getattr(self,NAVIGATION_CATALOG_ID, None)
        if nc!=None:
            return nc.getPhysicalPath()
        raise "ServiceError", "Can't locate %s" % NAVIGATION_CATALOG_ID

    security.declarePublic('getEasyResources')
    def getEasyResources(self, marker=None):
        return getattr(self,RESOURCE_CATALOG_ID, marker)

    security.declarePublic('getEasyResourcesURL')
    def getEasyResourcesURL(self):
        #Deprecated use getEasyResources.physicalURL instead
        raise "getEasyResourcesURL has been deprecated use getEasyResources.physicalURL instead."
        rc = getattr(self,RESOURCE_CATALOG_ID, None)
        if rc!=None:
            return rc.physicalURL
        raise "ServiceError", "Can't locate %s" % RESOURCE_CATALOG_ID

    security.declarePublic('getEasyResourcesPath')
    def getEasyResourcesPath(self):
        #Deprecated use getEasyResources.physicalPath instead
        raise "getEasyResourcesPath has been deprecated use getEasyResources.physicalPath instead."
        rc = getattr(self,RESOURCE_CATALOG_ID, None)
        if rc!=None:
            return rc.getPhysicalPath()
        raise "ServiceError", "Can't locate %s" % RESOURCE_CATALOG_ID

    security.declarePublic('getEasyNewsService')
    def getEasyNewsService(self, marker=None):
        return getattr(self,NEWS_SERVICE_ID, marker)

    security.declarePublic('getEasyNewsServiceURL')
    def getEasyNewsServiceURL(self, marker=None):
        #Deprecated use getEasyNewsService.physicalURL instead
        raise "getEasyNewsServiceURL has been deprecated use getEasyNewsService.physicalURL instead."
        rc = getattr(self,NEWS_SERVICE_ID, None)
        if rc!=None:
            return rc.physicalURL
        raise "ServiceError", "Can't locate %s" % NEWS_SERVICE_ID

    security.declarePublic('getEasyNewsServicePath')
    def getEasyNewsServicePath(self):
        #Deprecated use getEasyNewsService.physicalPath instead
        raise "getEasyNewsServicePath has been deprecated use getEasyNewsService.physicalPath instead."
        rc = getattr(self,NEWS_SERVICE_ID, None)
        if rc!=None:
            return rc.getPhysicalPath()
        raise "ServiceError", "Can't locate %s" % NEWS_SERVICE_ID

    security.declarePublic('getEasySearchService')
    def getEasySearchService(self, marker=None):
        return getattr(self, SEARCH_SERVICE_ID, marker)

    security.declarePublic('getTemplateService')
    def getTemplateService(self, marker=None):
        return getattr(self,EASYEDITORID, marker)

    #Deprecated??
    security.declarePublic('getEasyEditor')
    getEasyEditor=getTemplateService


    def _getTemplateServiceURL(self):
        editor=self.getTemplateService()
        if editor and hasattr(editor, '_getVirtualURL'):
            return editor._getVirtualURL()
        raise "ServiceError", "Can't locate %s" % EASYEDITORID

    security.declarePublic('tsURL')
    tsURL = ComputedAttribute(_getTemplateServiceURL, 1)

    security.declarePublic('getEasyEditorURL')
    getEasyEditorURL=_getTemplateServiceURL

    def _getTemplateServicePath(self):
        editor=self.getTemplateService()
        if editor and hasattr(editor, '_getVirtualPath'):
            return editor._getVirtualPath()
        raise "ServiceError", "Can't locate %s" % EASYEDITORID

    security.declarePublic('tsPath')
    tsPath = ComputedAttribute(_getTemplateServicePath, 1)

    security.declarePublic('getEasyEditorPath')
    getEasyEditorPath=_getTemplateServicePath


    #security.declarePublic('getEasyRoot')
    #def getEasyRoot(self):
    #    #Deprecated use getSiteRoot instead (and others in VirtualPath)
    #    raise "getEasyRoot has been deprecated use getSiteRoot instead (or others in VirtualPath)."
    #    #This method should use EasyVHM if available
    #    ee=getattr(self,EASYEDITORID, None)
    #    if ee is not None and hasattr(ee,'aq_inner'):
    #        return aq_parent(aq_inner(ee))
    #    return aq_inner(self)

    security.declarePublic('getEasyRootURL')
    def getEasyRootURL(self):
        #Deprecated use getSiteRoot (and others in VirtualPath) instead
        raise "getEasyRootURL has been deprecated use getSiteRoot instead (or others in VirtualPath)."
        root=self.getEasyRoot()
        if root and hasattr(root, 'virtualURL'):
            return root.virtualURL
        return self.virtualURL

    security.declarePublic('getEasyRootPath')
    def getEasyRootPath(self):
        #Deprecated use getSiteRoot (and others in VirtualPath) instead
        raise "getEasyRootPath has been deprecated use getSiteRoot instead (or others in VirtualPath)."
        root=self.getEasyRoot()
        if root and hasattr(root, 'virtualPath'):
            return root.virtualPath
        path=self.getPhysicalPath()
        vhm = getattr(self, EASY_VHM, None)
        if vhm:
            return vhm.get_site_root_path(path)
        return self.virtualPath

Globals.InitializeClass(EasyPublisherBase)
