# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/EasyWebDAVSupport.py,v 1.3 2004/09/09 13:25:45 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#
__version__='$Revision: 1.3 $'[11:-2]
__doc__='''EasyWebDAVSupport.'''

import Globals
from AccessControl import ClassSecurityInfo
from ExtensionClass import Base
from Products.EasyWorkflow.EasyWorkflowBase import NullDate
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
from OFS.DTMLMethod import DTMLMethod
from Products.PythonScripts.PythonScript import PythonScript

import sys
from traceback import *


from Products.CMFFormController.ControllerPageTemplate import ControllerPageTemplate
from Products.CMFFormController.ControllerPythonScript import ControllerPythonScript
from Products.CMFFormController.ControllerValidator import ControllerValidator
#from Products.EasyEditor.EasyDocument import EasyDocument
#from Products.EasyEditor.EasyNewsItem import EasyNewsItem
#from Products.EasyContactForm.EasyContactForm import EasyContactForm

from Products.EasyImage.EasyImage import EasyImage, TYPEINFOMAP
from Products.EasyFile.EasyFile import EasyFile
from Products.EasyCore.Utils import Tutils

from Products.EasyCore import MLOG_TAB


class EasyFTPSupport(Base):

    #security = ClassSecurityInfo()

    #security.declareProtected('WebDAV access', 'manage_addFolder')
    def manage_addFolder(self, id
                        , template = None
                        , title=''
                        , navtitle=''
                        , description=''
                        , language=''
                        , category=()
                        , subject=()
                        , effective_date=NullDate
                        , expiration_date=NullDate
                        , format='text/html'
                        , add_to_navigation=None
                        , REQUEST=None
                        ):
        """
            Add a new folder-like object with id *id*.  IF present,
            use the parent object's 'mkdir' action;  otherwise, just
            add a PortalFolder.
            to take control of the process by checking for a 'mkdir'
            action.
        """
        try:
            try:
                self.addNewDocument(  id
                                    , template = template
                                    , title=title
                                    , navtitle=navtitle
                                    , description=description
                                    , language=language
                                    , category=category
                                    , subject=subject
                                    , effective_date=effective_date
                                    , expiration_date=expiration_date
                                    , format=format
                                    , add_to_navigation=add_to_navigation
                                    )
            except:
                self.MKCOL_handler(id, REQUEST=REQUEST, RESPONSE=REQUEST.RESPONSE)
        except:
            try:
                from Products.EasyEditor.EasyFolder import EasyFolder
                ob=EasyFolder(id
                            , title=title
                            , navtitle=navtitle
                            , description=description
                            , language=language
                            , category=category
                          )
            except:
                from OFS.Folder import Folder
                ob=Folder()
                od.id=str(id)
                od.title=title
            self._setObject(id, ob)
        ob = self._getOb(id)
        try:
            ob.reindexObject()
        except:
            pass



#Globals.InitializeClass(EasyFTPSupport)

class EasyWebDAVSupport(EasyFTPSupport):

    #security = ClassSecurityInfo()

    def addNewDocument(self , id
                            , template = None
                            , title=''
                            , navtitle=''
                            , description=''
                            , language=''
                            , category=()
                            , subject=()
                            , effective_date=NullDate
                            , expiration_date=NullDate
                            , format='text/html'
                            , add_to_navigation=None
                            , REQUEST=None,RESPONSE=None
                        ):
        raise "Not implemented"

    def MKCOL_handler(self,id,REQUEST=None,RESPONSE=None):
        """
            Handle WebDAV MKCOL.
        """
        self.addNewDocument(id, REQUEST=REQUEST,RESPONSE=RESPONSE)

    def PUT_factory( self, name, typ, body ):
        """
            Dispatcher for PUT requests to non-existent IDs.  Returns
            an object of the appropriate type (or None, if we don't
            know what to do).
        """
        try:
            if name and name.endswith('.pt'):
                ob = ZopePageTemplate(name, body, content_type=typ)

            elif name and name.endswith('.cpt'):
                ob = ControllerPageTemplate(name, body, content_type=typ)

            elif typ in ('text/html', 'text/xml', 'text/plain') or name and (name.endswith('.dtml') or name.endswith('.html') or name.endswith('.htm')):
                if name and (name.endswith('.html') or name.endswith('.htm')):
                    name=name[:(len(name) - name.rfind('.'))]+'.dtml'
                ob = DTMLMethod( '', __name__=name )

            elif typ=='text/x-python' or (name and name.endswith('.pys')):
                ob = PythonScript( name )

            elif typ=='text/x-python' or (name and  name.endswith('.cpy')):
                ob = ControllerPythonScript( name )

            elif typ=='text/x-python' or (name and  name.endswith('.vpy')):
                ob = ControllerValidator( name )

            elif typ[:6]=='image/' or name[-3:].upper() in TYPEINFOMAP.keys():
                ob = EasyImage(name, body, '', content_type=typ)

            else:
                ob = EasyFile(name, body, '', content_type=typ)


        except:
            exc = sys.exc_info()
            LOG('EasyWebDAVSupport', ERROR, "Can't create sub object: %s: %s" % exc[:2], error=exc)
            return None
        return ob


#Globals.InitializeClass(EasyWebDAVSupport)
