# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/CSSStylesFeature.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""CSS Styles Feature

$Colliberty: CSSStylesFeature.py,v 0.0.2 2001/08/06 22:06:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Features import FeatureBase, FEATUREADDPERMISSION
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from Products.EasyCore.Utils.HTMLFormHelpers import selectTemplateDTML
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


FEATUREPLUGINID = 'CSSStylesFeature'
PLUGINKIND = 'HTML'

class CSSStylesFeature(FeatureBase):
    """CSSStylesFeature Objects"""

    meta_type = FEATUREPLUGINID

    elementid = 'setCSS_Style'
    command = ""
    actionHandler = 'handleCSS_Style'
    updateAppearenceHandler = 'updateCSSStylesFeature'
    usesLatched = 0
    feature_type = UI_SELECT

    dropdown_group = "Styles"
    dropdown_group_order = 0

    def renderjsDropDown(self,client=None,REQUEST=None):
        return selectTemplateDTML( \
                items=self.styleMap(), \
                activekeys=[], \
                name='setCSS_Style', \
                onClick='handleCSSStylesFeature(this);' \
            )


    def renderjsDropDownHandler(self,client=None,REQUEST=None):
        return """
            function handleCSSStylesFeature(self) {
                if (self.value!=currStyleClass) {
                    if (currRange != null) {
                        if (currStyleElement!=null) {
                            currStyleElement.className=self.value;
                            currStyleClass=self.value;
                            handleDisplayChangeEvent();
                            editor.focus();
                            currRange.select();
                            handleDisplayChangeEvent();
                        } else {
                            if (currParentElement==currEditableRegion) {
                                currRange.expand();
                                currRange.select();
                            }
                        }
                    }
                }
            }
            """



    def renderjsUpdateApperenceCall(self,client=None,REQUEST=None):
        return r"""
            if (currStyleClass!=null) setCSS_Style.value=currStyleClass;
            else {
                setCSS_Style.value = "";
            }
            """


Globals.InitializeClass(CSSStylesFeature)



def initialize(context):
    """Initialize Feature Product"""

    context.registerDropDownGroup('Styles',0)
    context.registerEasyFeature(CSSStylesFeature,FEATUREPLUGINID,icon="icons/EasyImage.gif")

