# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/Indentation.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""Indentation

$Colliberty: Indentation.py,v 0.0.1 2001/09/01 10:39:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions



class Indent(FeatureBase):
    """Indent PlugIn Objects"""

    meta_type = 'Indent'
    __plugin_kind__ = 'HTML'

    elementid = 'IndentButton'
    command = DECMD_INDENT
    accesskey = ''
    actionHandler = 'setIndent'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Indentations"
    button_group_order = 1


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                title="Indent"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //INDENT BUTTON
            function setIndent(){
                if(editor.document.queryCommandEnabled(DECMD_INDENT)) {
                    editor.document.execCommand(DECMD_INDENT);
                }
            }
        """



Globals.InitializeClass(Indent)

class Outdent(FeatureBase):
    """Outdent PlugIn Objects"""

    meta_type = 'Outdent'
    __plugin_kind__ = 'HTML'

    elementid = 'OutdentButton'
    command = DECMD_OUTDENT
    accesskey = ''
    actionHandler = 'setOutdent'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "Indentations"
    button_group_order = 0


    def renderjsButton(self,client=None,REQUEST=None):
        return  HTML("""
            <BUTTON
                id=&dtml-elementid;
                class=justplain
                style="width:20;margin:2;"
                onClick="this.blur();&dtml-actionHandler;();window.event.cancelBubble=true;"
                onMouseOver="mouseOverButton(this);"
                onMouseOut="mouseOffButton(this);"
                accesskey=&dtml-accesskey;><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return  """
            //OUTDENT BUTTON
            function setOutdent(){
                if(editor.document.queryCommandEnabled(DECMD_OUTDENT)) {
                    editor.document.execCommand(DECMD_OUTDENT);
                }
            }
        """


Globals.InitializeClass(Outdent)



def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('Indentations',4)
    context.registerEasyFeature(Indent,Indent.meta_type,icon="icons/Indent.gif")
    context.registerEasyFeature(Outdent,Outdent.meta_type,icon="icons/Outdent.gif")
