# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Features/InlineUnderline.py,v 1.1 2004/06/28 10:04:17 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""InlineUnderline

$Colliberty: InlineUnderline.py,v 0.0.1 2001/06/04 15:37:00 johanc Exp $"""
__version__='$Revision: 1.1 $'[11:-2]


import Globals
from Globals import HTML, DTMLFile
from string import join,split
from Features import FeatureBase, FEATUREADDPERMISSION

from Products.EasyCore.Utils.FunctionTemplate import FunctionTemplate
from Products.EasyEditor.EasyEditorClient.EasyEditorConstants import *

from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions


FEATUREPLUGINID = 'InlineUnderline'
PLUGINKIND = 'HTML'


class InlineUnderline(FeatureBase):
    """InlineUnderline PlugIn Objects"""

    meta_type = FEATUREPLUGINID
    __plugin_kind__ = PLUGINKIND

    elementid = 'underlineButton'
    command = DECMD_UNDERLINE
    accesskey = 'u'
    actionHandler = 'setUnderline'
    updateAppearenceHandler = UH_STANDARDBUTTONHANDLER
    usesLatched = 1
    feature_type = UI_BUTTON

    # Control arguments for Button Placement
    button_group = "TypeStile"
    button_group_order = 2


    manage_main = DTMLFile('manage_main_HTMLStylesFeature', globals())

    def manage_edit(self, title, REQUEST=None):
        """Save Changes"""
        self.title = title
        if REQUEST is not None:
            return self.manage_main(self,REQUEST,management_view='Edit')


    def renderjsButton(self,client=None,REQUEST=None):
        return HTML("""
                <BUTTON
                    id="underlineButton"
                    class="justplain"
                    style="width:20;margin:2;"
                    onClick="this.blur();setunderline();window.event.cancelBubble=true;"
                    onMouseOver="mouseOverButton(this);" onMouseOut="mouseOffButton(this);"
                    title="Underline"
                    accesskey=u><img src="/&dtml-icon;" widht="16" height="16" alt="" border="0"></BUTTON>
            """, globals())(self,REQUEST)


    def renderjsButtonHandler(self,client=None,REQUEST=None):
        return """
            //underline BUTTON
            function setunderline(){
                if(editor.document.queryCommandSupported(DECMD_UNDERLINE)||editor.document.queryCommandIndeterm(DECMD_UNDERLINE)){
                    editor.document.execCommand(DECMD_UNDERLINE);
                }
            }
            """


Globals.InitializeClass(InlineUnderline)


def initialize(context):
    """Initialize Feature Product"""

    context.registerButtonGroup('TypeStile',0)
    context.registerEasyFeature(InlineUnderline,FEATUREPLUGINID,icon="icons/InlineUnderline.gif")