# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Storage/DTMLStorage.py,v 1.4 2004/09/09 13:25:45 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""Default Storage

$Colliberty: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]

import Globals
from Globals import HTML
from Storage import EasyStorageBase
from OFS.DTMLMethod import addDTMLMethod
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base, aq_inner, aq_chain
from types import StringType
from string import atoi


#Move this to it's own class.
try:
    from mx.Tidy.Tidy import tidy
except:
    tidy=None



from Products.EasyCore import MLOG_TAB

_marker = []

class DTMLStorage(EasyStorageBase):
    """A DTMLStorage Object """

    security = ClassSecurityInfo()
    storage_type="DTMLStorage"
    value_type='string'

    property_cols=72
    property_rows_max=40
    property_rows_min=20
    property_rows_add=3



    def compareHistoryItem(self, editablecontainer, region, item):
        """\
        Compares the Region/Storage with the one added in the History.
        If they differ the region needs to be transformed and re-initiated.
        Return 1 or 0 where 1 is means the are equal.
        """
        raise "Not Implemented"
        ###if item:
        ###    if item.storage_type != self.storage_type or \
        ###           item.property_type != self.property_type or \
        ###           item.property_mode != self.property_mode or \
        ###           item.property_label != region.label or \
        ###           item.property_select_variable != self.property_select_variable or \
        ###           item.last_changed != region.lastChanged():
        ###       return 0
        ###    return 1
        ###return 0

    def validityCheck(self, editablecontainer, region):
        raise "Not Implemented"
        ###prop=self.getPropertyInfoFor(editablecontainer, region)
        ###return prop and hasattr(editablecontainer, region.storagecontainerid)


    def do_initilized(self, editablecontainer, region):
        raise "Not Implemented"
        ###self.do_add(editablecontainer, region, self.getDefault(region))

    def do_transform(self, editablecontainer, region, item):
        raise "Not Implemented"
        ###old_storage=item.getStorage()
        ###if old_storage:
        ###    value=old_storage.getValueForType(editablecontainer, region, self.value_type)
        ###    old_storage.manage_delete(editablecontainer, region)
        ###    self.do_add(editablecontainer, region, value)
        ###    return
        ###self.do_initilized(editablecontainer, region)


    def do_add(self, editablecontainer, region, value):
        raise "Not Implemented"
        ###self._saveProperty(editablecontainer, region, value)
        ###
        ###self._initRSHistoryItem(editablecontainer, region)
        ###self._setLastChanged(editablecontainer, region, region.lastChanged())


    def _getValueForType(self, editablecontainer, region, value_type, default=None):
        """\
        Returns the value of the requested type if possible otherwice default is returned.
        """
        raise "Not Implemented"
        ###if value_type=='list':
        ###    return list(getattr(editablecontainer, region.storagecontainerid, default))
        ###elif value_type=='string':
        ###    return getattr(editablecontainer, region.storagecontainerid, default)
        ###return default


    ## XXX Interface

    security.declarePrivate('manage_delete_allowed')
    def manage_delete_allowed(self, editablecontainer, region, REQUEST=None):
        raise "Not Implemented"
        ###return 1

    security.declarePrivate('manage_save')
    def manage_save(self, editablecontainer, region, value=None, REQUEST=None):
        if self.hasChanged(editablecontainer, region):
            self.manage_delete(editablecontainer, region, REQUEST=REQUEST)
            self._setLastChanged(editablecontainer, region, region.lastChanged())
        if value is None:
            value=self.do_get(editablecontainer, region, self.getDefault(region))
        _storage = getattr(aq_base(editablecontainer),'_' + region.storagecontainerid + '_storage',None)
        if _storage is not None and _storage!=self.id:
            storage = self.getStorage(_storage)
            if storage is not None and hasattr(editablecontainer, region.storagecontainerid):
                storage.manage_delete(editablecontainer, region, REQUEST=REQUEST)
            elif storage is None: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)

        self._saveDTML(region.storagecontainerid, value, editablecontainer, region, REQUEST=REQUEST)
        setattr(aq_base(editablecontainer),'_' + region.storagecontainerid + '_storage',self.id)

    def _saveDTML(self, name, value, editablecontainer, region, REQUEST=None):
        if name not in editablecontainer.objectIds(spec='DTML Method'):
            try:
                addDTMLMethod(editablecontainer, name, name)
            except:
                delattr(editablecontainer, name)
                addDTMLMethod(editablecontainer, name, name)
        obj = editablecontainer._getOb(name)
        if not value: value=''
        obj.manage_edit(str(value), obj.title, REQUEST=REQUEST)


    security.declarePrivate('manage_load')
    def manage_load(self, editablecontainer, region, default=None, REQUEST=None):
        if region.storagecontainerid in editablecontainer.objectIds(spec='DTML Method'):
            return editablecontainer._getOb(region.storagecontainerid)
        else:
            return getattr(aq_base(editablecontainer), region.storagecontainerid, default)

    def manage_initilized(self, editablecontainer, region, REQUEST=None):
        return region.storagecontainerid in editablecontainer.objectIds(spec='DTML Method')

    security.declarePrivate('manage_delete')
    def manage_delete(self, editablecontainer, region, REQUEST=None):
        if editablecontainer._getOb(region.storagecontainerid, default=None) is not None:
            editablecontainer._delObject(region.storagecontainerid)

    security.declarePrivate('manage_compare')
    def manage_compare(self, editablecontainer, region, obj, REQUEST=None):
        local_obj=self.manage_load(editablecontainer, region, _marker, REQUEST=REQUEST)
        if local_obj is _marker: return 0
        if getattr(obj, 'meta_type', "marker1")!=getattr(local_obj, 'meta_type', "marker2"):
            return 0
        return obj.read()==local_obj.read()

    security.declarePrivate('manage_copy')
    def manage_copy(self, editablecontainer, region, parent, REQUEST=None):
        ob = self.manage_load(editablecontainer, region, REQUEST=REQUEST)
        ob = ob._getCopy(editablecontainer)
        ob._setId(region.storagecontainerid)
        if hasattr(parent, '_setObject'):
            parent._setObject(region.storagecontainerid, ob)
        else:
            setattr(parent, region.storagecontainerid, ob)

    security.declarePrivate('manage_modification_date')
    def manage_modification_date(self, name, editablecontainer, REQUEST=None):
        storage_obj = getattr(aq_base(editablecontainer), name, None)
        if storage_obj is not None:
            return storage_obj.bobobase_modification_time()
        return editablecontainer.bobobase_modification_time()


    def render_html_view(self, editablecontainer, region, REQUEST=None):
        #content=region.manage_load(editablecontainer, region, REQUEST=REQUEST)
        value=str( self.manage_load(editablecontainer, region, self.getDefault(region), REQUEST=REQUEST) )
        return self.do_html_view(editablecontainer, region, id=region.id, value=value)


    def do_html_view(self, editablecontainer, region, defaults=None, **kw):
        rows_max=getattr(region, 'property_rows_max', self.property_rows_max)
        rows_min=getattr(region, 'property_rows_min', self.property_rows_min)
        rows_add=getattr(region, 'property_rows_add', self.property_rows_add)
        cols=getattr(region,'property_cols', self.property_cols)
        rows=len(kw['value'].split('\n'))+rows_add
        rows=rows>rows_max and rows_max or rows
        rows=rows<rows_min and rows_min or rows
        if defaults is None:
            defaults={'cols':cols,'rows':rows}
        defaults.update(kw)
        return """\
            <textarea
                name="%(id)s"
                wrap="off"
                cols="%(cols)s"
                rows="%(rows)s"
                style="width:100%%">%(value)s</textarea>""" % defaults


    ##Storage Init, Config and Change

    render_view_storage_conf = HTML("""
      <dtml-with "region">
        <table width="100%" cellspacing="0" cellpadding=2">
          <tr><td colspan="2" class="form-label">Size</td></tr>
          <tr class="EProw-hilite">
            <td class="form-label" width="170">Columns</td>
            <td><input type="text" name="property_cols:int" value="&dtml.missing-property_cols;"></td>
          </tr>
          <tr class="EProw-hilite">
            <td class="form-label" width="170">Rows (max)</td>
            <td><input type="text" name="property_rows_max:int" value="&dtml.missing-property_rows_max;"></td>
          </tr>
          <tr class="EProw-hilite">
            <td class="form-label" width="170">Rows (min)</td>
            <td><input type="text" name="property_rows_min:int" value="&dtml.missing-property_rows_min;"></td>
          </tr>
          <tr class="EProw-hilite">
            <td class="form-label" width="170">Rows (add to lines)</td>
            <td><input type="text" name="property_rows_add:int" value="&dtml.missing-property_rows_add;"></td>
          </tr>
        </table>
      </dtml-with "region">
    """, globals())

    security.declarePrivate('manage_view_storage_conf')
    def manage_view_storage_conf(self, region, REQUEST=None):
        return self.render_view_storage_conf(self, region=region, REQUEST=REQUEST)

    security.declarePrivate('manage_save_storage_conf')
    def manage_save_storage_conf(self, region, REQUEST=None):
        region.property_cols = REQUEST.get('property_cols',getattr(region,'property_cols', self.property_cols))
        max_v = REQUEST.get('property_rows_max',getattr(region,'property_rows_max', self.property_rows_max))
        min_v = REQUEST.get('property_rows_min',getattr(region,'property_rows_min', self.property_rows_min))
        add_v = REQUEST.get('property_rows_add',getattr(region,'property_rows_add', self.property_rows_add))
        max_v=max(max_v, min_v)
        min_v=min(max_v, min_v)
        add_v=min(min_v, add_v)
        region.property_rows_max = max_v
        region.property_rows_min = min_v
        region.property_rows_add = add_v

        #return self.manage_view_storage_conf(region, REQUEST=REQUEST)


Globals.InitializeClass(DTMLStorage)




def initialize(context):
    """Initialize Storage Product"""

    context.registerEasyStorage(DTMLStorage,'DTMLStorage')

