# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Storage/DatePropertyStorage.py,v 1.4 2004/09/20 12:17:29 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#


__doc__="""DatePropertyStorage

$Colliberty: DatePropertyStorage.py,v 1.4.37 2001/10/12 18:08:00 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]


import Globals
from PropertyStorage import PropertyStorage
from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from types import StringType, ListType, TupleType
from string import atoi, capitalize

from Products.EasyCore import MLOG_TAB

_marker=[]

POSSIBLE_LINES='possible_'

class DatePropertyStorage(PropertyStorage):
    """A DatePropertyStorage Object """

    property_type = 'date'
    storage_type="Date"
    value_type='date'

    def render_html_view(self, editablecontainer, region, REQUEST=None):
        value=self.manage_load(editablecontainer, region, self.getDefault(region), REQUEST=REQUEST)
        return self.do_html_view(editablecontainer, region, id=region.id, value=value)

    def do_html_view(self, editablecontainer, region, defaults=None, **kw):
        REQUEST=getattr(editablecontainer ,'REQUEST', None)
        cols=50
        if REQUEST is not None and REQUEST.has_key('dtpref_cols') and REQUEST.has_key('dtpref_rows'):
            dtpref_cols=REQUEST.dtpref_cols
            if type(dtpref_cols) is StringType and dtpref_cols[-1]=='%': dtpref_cols=dtpref_cols[:-1]
            cols=max(atoi(dtpref_cols)-15,20)
        if defaults is None:
            defaults={'size':cols,}
        defaults.update(kw)
        return """<input type="text" name="%(id)s:string" value="%(value)s" size="%(size)s">""" % defaults



Globals.InitializeClass(DatePropertyStorage)

def initialize(context):
    """Initialize PropertyStorage"""

    context.registerEasyStorage(DatePropertyStorage,     'DatePropertyStorage')
