# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Storage/ZBabelObjectStorage.py,v 1.2 2004/09/09 13:25:46 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

#THIS WIL PROBABLY NOT WORK

__doc__="""ZBabelObjectStorage

$Colliberty: Storage.py,v 0.0.1 2001/05/14 22:06:00 johanc Exp $"""
__version__='$Revision: 1.2 $'[11:-2]

import Globals
from Storage import EasyStorageBase
try:
    from Products.ZBabel.ZBabelObject import manage_addZBabelObject
    from OFS.DTMLMethod import addDTMLMethod
    from AccessControl import ClassSecurityInfo
    from Acquisition import aq_base

    from zLOG import LOG, ERROR
    import sys

    StringType = type('')

    class ZBabelObjectStorage(EasyStorageBase):
        """A ZBabelObjectStorage Object """

        security = ClassSecurityInfo()

        def _saveZBabelObject(self, name, value, editablecontainer, region):
            if name not in editablecontainer.objectIds(spec='ZBabel Object'):
                try:
                    editablecontainer.manage_addProduct['ZBabel'].manage_addZBabelObject(name, title=name, meta_type='DTML Method')
                except:
                    LOG("ZBabelObjectStorage:_saveZBabelObject",ERROR, "Can't create an EditableRegion named '%s' in '%s'" % (name,editablecontainer.getId()), error=sys.exc_info())
            try:
                zbo = editablecontainer._getOb(name)
            except:
                zbo = editablecontainer
            language=zbo.findPreferredLanguage()
            if language not in zbo.objectIds(spec='DTML Method'):
                addDTMLMethod(zbo, language, language)
            obj = zbo._getOb(language)
            obj.manage_edit(value,obj.title)
            setattr(aq_base(editablecontainer),'_' + name + '_storage',self.id)

        security.declarePrivate('manage_save')
        def manage_save(self, editablecontainer, region, value=None, REQUEST=None):
            _storage = getattr(aq_base(editablecontainer),'_' + region.storagecontainerid + '_storage',None)
            if _storage is not None and _storage!=self.id:
                storage = self.getStorage(_storage)
                if storage is not None and hasattr(editablecontainer,region.storagecontainerid):
                    storage.manage_delete(editablecontainer, region)
                elif storage is None: raise "StorageException", "Need to have storage [%s] installed to be able to work with this region." % (_storage,)
            self._saveZBabelObject(region.storagecontainerid, value, editablecontainer, region)

        security.declarePrivate('manage_load')
        def manage_load(self,editablecontainer, region, default=None, REQUEST=None):
            language='en'
            if region.storagecontainerid in editablecontainer.objectIds(spec='ZBabel Object'):
                zbo = editablecontainer._getOb(region.storagecontainerid)
                language=zbo.findPreferredLanguage()
                if language and language in zbo.objectIds(spec='DTML Method'):
                    return zbo._getOb(language)
                else:
                    return getattr(aq_base(zbo), region.storagecontainerid, default)
            else:
                return getattr(aq_base(editablecontainer), region.storagecontainerid, default)

        security.declarePrivate('manage_delete')
        def manage_delete(self, editablecontainer, region, REQUEST=None):
            editablecontainer._delObject( region.storagecontainerid)


    Globals.InitializeClass(ZBabelObjectStorage)




    def initialize(context):
        """Initialize Storage Product"""

        context.registerEasyStorage(ZBabelObjectStorage,'ZBabelObjectStorage')


except:
    from zLOG import LOG, INFO
    LOG("ZBabelObjectStorage", INFO, "ZBabel is not installed in the system. ZBabelObjectStorage will not be awailable.")