# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/Styles/StylesManage.py,v 1.2 2004/09/28 10:04:50 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__ = """StylesManage"""
__version__='$Revision: 1.2 $'[11:-2]



import Globals
from ExtensionClass import Base
from Products.EasyEditor.Styles.StylesConf import *
from AccessControl import ClassSecurityInfo
from Products.EasyCore import EasyCorePermissions

class StylesManage(Base):

    security = ClassSecurityInfo()

    __static_exports__=['styleSheet']

    security.declareProtected(AccessContentsInformation, 'hasStyles')
    def hasStyles(self):
        return len(self.objectIds(spec=STYLEMETATYPE))

    security.declareProtected(AccessContentsInformation, 'hasStyle')
    def hasStyle(self, styleid):
        return styleid in self.objectIds(spec=STYLEMETATYPE)

    security.declareProtected(AccessContentsInformation, 'getStyle')
    def getStyle(self,styleid):
        style = getattr(self, styleid, None)
        if style is not None and style.meta_type == STYLEMETATYPE:
            return style
        raise AttributeError, "Can't find a style with the id: %s" % (styleid,)

    security.declareProtected(AccessContentsInformation, 'styleIds')
    def styleIds(self,spec=None):
         return self.objectIds(spec=STYLEMETATYPE)

    security.declareProtected(AccessContentsInformation, 'styleValues')
    def styleValues(self,spec=None):
        return self.objectValues(spec=STYLEMETATYPE)

    security.declareProtected(AccessContentsInformation, 'styleItems')
    def styleItems(self,spec=None):
        return self.objectItems(spec=STYLEMETATYPE)

    security.declareProtected(AccessContentsInformation, 'styleMap')
    def styleMap(self):
        return map(lambda x: (x.id, x.title or x.id ), self.objectValues(spec=STYLEMETATYPE))

    security.declareProtected(AccessContentsInformation, 'styleValuesFor')
    def styleValuesFor(self, styles, spec=None):
        if type(styles)==type(''): styles = [styles]
        if type(styles)==type(()): styles = list(styles)
        return filter(lambda x, styles=styles: x.id in styles, self.styleValues())

    security.declareProtected(AccessContentsInformation, 'styleItemsFor')
    def styleItemsFor(self,styles,spec=None):
        return map(lambda x: (x.id, x), self.styleValuesFor(styles))

    security.declareProtected(AccessContentsInformation, 'styleMapFor')
    def styleMapFor(self,styles):
        return map(lambda x: (x.id, x.title or x.id ), self.styleValuesFor(styles))

    security.declareProtected(EasyCorePermissions.View, 'styleSheet')
    def styleSheet(self, link=None, inline=None, REQUEST=None):
        """Renders a CSS Style Sheet and sets the HTTP Content-Type if the request comes from the web."""
        cssresult = ""
        for style in self.styleValues():
            cssresult = cssresult + '.' + style.id + ' '
            cssresult = cssresult + '{ '
            cssresult = cssresult + style.csscode
            cssresult = cssresult + ' }' + '\n'

        if inline:
            return '<STYLE>' + '\n' + cssresult + '\n' + '</STYLE>'
        if link:
            return '<link type="text/css" href="%s/styleSheet" REL="stylesheet">' % (self.absolute_url())
        if REQUEST:
            REQUEST.RESPONSE.setHeader('Content-Type', 'text/css')
            return cssresult
        return cssresult
