# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyEditor/__init__.py,v 1.3 2004/06/29 14:14:15 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#
#

__doc__ = """EasyEditor initialization module."""
__version__='$Revision: 1.3 $'[11:-2]



import EasyEditor, Storage, Features
include_modules = (EasyEditor, Storage, Features, )

import EasyEditable, EasyTemplates, EditableRegions
include_modules = include_modules + (EasyEditable, EasyTemplates, EditableRegions)

import EasyDocument, EasyRoot, EasyFolder; include_modules = include_modules + (EasyDocument, EasyRoot,EasyFolder)

import Styles; include_modules = include_modules + (Styles,)


import BrowserFolder; include_modules = include_modules + (BrowserFolder,)

import EasyNewsItem; include_modules = include_modules + (EasyNewsItem,)

import EasyPropertyContainer; include_modules = include_modules + (EasyPropertyContainer,)


#import MetaDataTemplates; include_modules = include_modules + (MetaDataTemplates,)

import EasySimpleObject; include_modules = include_modules + (EasySimpleObject,)

from ImageFile import ImageFile




def initialize(context):
    """Initialize the EasyEditor product.
    """
    for m in include_modules:
            m.initialize(context)



misc_={
    'EasyEditor':           ImageFile('icons/EasyEditor.gif',   globals(),),
    'EasySimpleItem':       ImageFile('icons/EasySimpleItem.gif',   globals()),
    'EasyTemplate':         ImageFile('icons/EasyTemplate.gif',   globals()),
    'button_seperator.gif': ImageFile('images/button_seperator.gif',   globals()),
    'transparent50.gif':    ImageFile('images/transparent50.gif',   globals()),
    'object_browser_up.gif':ImageFile('images/object_browser_up.gif',   globals()),
    }

from Products.EasyEditor.BrowserRegistry import BrowserRegistry

BrowserRegistry.register(('MSIE 6.0','windows'), ('DHTMLEditionComponent5.5',))
BrowserRegistry.register(('MSIE 5.5','windows'), ('DHTMLEditionComponent5.5',))




from App.FactoryDispatcher import FactoryDispatcher

import Acquisition, sys, Products
from AccessControl.PermissionMapping import aqwrap
import ExtensionClass
from Products.EasyCore.EasyEditorConf import EASYEDITORID


class ofWrapper(ExtensionClass.Base):
    def __init__(self, o):
        self._o=o
    def __of__(self, parent): return self.__dict__['_o']


class __FactoryDispatcher__(FactoryDispatcher):
    """Overrides the factory dispatcher to enable adding of
       the same meta_types under different names"""

    add_by_template=None
    template_id=None
    klass=None

    def __getattr__(self, name):
        if name[:13]=='AddByTemplate':
            self.add_by_template=True
            add, template_id, klass=name.split('-')
            self.template_id=template_id
            self.klass=klass
            if hasattr(self, 'add%sWithTemplateForm'%klass):
                return getattr(self, 'add%sWithTemplateForm'%klass)

        p=self.__dict__['_product']
        d=p.__dict__
        if hasattr(p,name) and d.has_key(name):
            m=d[name]
            w=getattr(m, '_permissionMapper', None)
            if w is not None:
                m=ofWrapper(aqwrap(m, getattr(w,'aq_base',w), self))

            return m



        raise AttributeError, name

