# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyFile/__init__.py,v 1.4 2004/09/14 12:17:08 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__="""EasyFile $Id: __init__.py,v 1.4 2004/09/14 12:17:08 johanc Exp $"""
__version__='$Revision: 1.4 $'[11:-2]

import EasyFile
try:
    import EasyExcelFile
except:
    EasyExcelFile=None

from zLOG import LOG, WARNING
import Products
from Globals import DTMLFile
from OFS.content_types import guess_content_type
from Products.EasyCore.Utils.Tutils import filename2id_title, getValidId
from Products.EasyCore.EasyCorePermissions import EasyFileAdd



def getProductClass(name, default=None):
    for entry in Products.meta_types:
        if entry.get("name", None) == name:
            return entry.get("instance", default)
    return default

manage_addEasyFileForm=DTMLFile('dtml/manage_addEasyFileForm', globals())

def manage_addEasyFile(self, id, file
                        , title=''
                        , category=()
                        , subject=()
                        , description=''
                        , language=''
                        , content_type=''
                        , precondition=''
                        , REQUEST=None
                        ):
    """
    Add a new EasyFile object.

    Creates a new File object 'id' with the contents of 'file'.
    """
    filename=getattr(file, 'filename', id)
    if callable(getattr(file, 'read',None)):
        preview_file=file.read(100)
    else:
        preview_file=file

    if not content_type:
        content_type, content_enc=guess_content_type(filename, preview_file, content_type)

    EasyImage=getProductClass('EasyImage', None)

    self = self.this()

    if content_type[0:5].lower()=='image' and EasyImage:
        id, title_deprecated = filename2id_title(filename, id, title, cut_extension=0)
        id=getValidId(self, id)
        fileObj=EasyImage(id, file, title
                          , category=category
                          , subject=subject
                          , description=description
                          , language=language
                          , content_type=content_type
                          , precondition=precondition
                      )
    else:
        id, title_deprecated = filename2id_title(filename, id, title, cut_extension=0)
        id=getValidId(self, id)
        fileObj=EasyFile.EasyFile(id, file, title
                          , category=category
                          , subject=subject
                          , description=description
                          , language=language
                          , content_type=content_type
                          , precondition=precondition
                       )
    self._setObject(id, fileObj)
    fileObj = self._getOb(id)
    fileObj.manage_upload(file, REQUEST=REQUEST)
    if content_type:
        fileObj.content_type=content_type

    if REQUEST is not None:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect('%s/manage_main' % (url,))
    return id


def initialize(context):
    """Initialize EasyFile Product"""

    context.registerClass (
            EasyFile.EasyFile,
            permission=EasyFileAdd,
            icon='icons/EasyFile.gif',
            constructors=(manage_addEasyFileForm, manage_addEasyFile),
            meta_type = EasyFile.EasyFile.meta_type,
            category='Easy Publisher',
            )

    if EasyExcelFile:
        context.registerClass (
            EasyExcelFile.EasyExcelFile,
            permission=EasyFileAdd,
            icon='icons/EasyExcelFile.gif',
            constructors=(EasyExcelFile.manage_addEasyExcelFileForm, EasyExcelFile.manage_addEasyExcelFile),
            meta_type = EasyExcelFile.EasyExcelFile.meta_type,
            category='Easy Publisher',
            )

