# coding: iso-8859-1
# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyImage/__init__.py,v 1.3 2004/08/21 07:50:39 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

__doc__="""EasyImage __init__"""
__version__='$Revision: 1.3 $'[11:-2]


import EasyImage
from zLOG import LOG, WARNING
import Products
from Globals import DTMLFile
from OFS.content_types import guess_content_type
from Products.EasyCore.Utils.Tutils import filename2id_title, getValidId, xlate2url

def getProductClass(name, default=None):
    for entry in Products.meta_types:
        if entry.get("name", None) == name:
            return entry.get("instance", default)
    return default

manage_addEasyImageForm=DTMLFile('dtml/manage_addEasyImageForm', globals())

#    """Add EasyImage"""
def manage_addEasyImage(self, id, file
                        , title=''
                        , category=()
                        , subject=()
                        , description=''
                        , language=''
                        , content_type=''
                        , precondition=''
                        , REQUEST=None
                        ):
    """
    Add a new EasyImage object.

    Creates a new Image object 'id' with the contents of 'file'.
    """
    filename=getattr(file, 'filename',id)
    if callable(getattr(file, 'read',None)):
        preview_file=file.read(100)
    else:
        preview_file=file
    if not content_type:
        content_type, content_enc = guess_content_type(filename, preview_file, content_type)

    EasyFile=getProductClass('EasyFile', None)

    self = self.this()

    if content_type[0:5].lower()!='image' and EasyFile:
        id, title_deprecated = filename2id_title(filename, id, title, cut_extension=0)
        id=getValidId(self, id)
        fileObj=EasyFile(id, file, title
                          , category=category
                          , subject=subject
                          , description=description
                          , language=language
                          , content_type=content_type
                          , precondition=precondition
                       )
    else:
        id, title_deprecated = filename2id_title(filename, id, title, cut_extension=0)
        id=getValidId(self, id)
        fileObj=EasyImage.EasyImage(id, file, title
                          , category=category
                          , subject=subject
                          , description=description
                          , language=language
                          , content_type=content_type
                          , precondition=precondition
                       )
    self._setObject(id, fileObj)
    imgObj = self._getOb(id)
    imgObj.manage_upload(file, REQUEST=REQUEST)
    if content_type:
        imgObj.content_type=content_type

    if REQUEST is not None:
        try:    url=self.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect('%s/manage_main' % (url,))

    return id

def initialize(context):
    """Initialize EasyImage Product"""

    context.registerClass (
            EasyImage.EasyImage,
            permission=EasyImage.EasyImageAdd,
            icon='icons/EasyImage.gif',
            constructors=(manage_addEasyImageForm, manage_addEasyImage),
            meta_type = EasyImage.EasyImage.meta_type,
            category='Easy Publisher',
            )


