# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyNotification/DefaultNotifications.py,v 1.1 2004/06/28 10:05:47 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""Default Notifications for EasyNotification"""
__version__='$Revision: 1.1 $'[11:-2]


from Globals import HTML


submit_message = """Document <dtml-var id> was submitted for review by <dtml-var changed_by>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
New state...... <dtml-var new_state>
Old state...... <dtml-var old_state>
View .......... <dtml-var absolute_url>/preview_html
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>

"""

deny_message = """Document <dtml-var id> was denied for publishing by <dtml-var changed_by>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
New state...... <dtml-var new_state>
Old state...... <dtml-var old_state>
View .......... <dtml-var absolute_url>
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>

"""

publish_message = """Document <dtml-var id> was published by <dtml-var changed_by>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
New state...... <dtml-var new_state>
Old state...... <dtml-var old_state>
View .......... <dtml-var absolute_url>/preview_html
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>

"""

master_publish_message = """Master document <dtml-var id> was published by <dtml-var changed_by>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
New state...... <dtml-var new_state>
Old state...... <dtml-var old_state>
View .......... <dtml-var absolute_url>/preview_html
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>

"""

revoke_message = """Document <dtml-var id> was revoked from publishing by <dtml-var changed_by>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
New state...... <dtml-var new_state>
Old state...... <dtml-var old_state>
View .......... <dtml-var absolute_url>/preview_html
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>

"""

delegate_message = """You have been assigned as an Author for <dtml-var id>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
Workflow state. <dtml-var old_state>
View .......... <dtml-var absolute_url>/preview_html
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>


"""

retract_message = """Document <dtml-var id> was retracted from submittion by <dtml-var changed_by>.

Title.......... <dtml-var title>
Date........... <dtml-var date>
New state...... <dtml-var new_state>
Old state...... <dtml-var old_state>
View .......... <dtml-var absolute_url>/preview_html
Edit .......... <dtml-var absolute_url>/manage_editor
Review ........ <dtml-var absolute_url>/manage_publishform

Comment:
<dtml-var comment>

"""


notifiable_workflow_transitions={
                'notify_submit':    (
                                        'Notify on submit',
                                        '[Notify Submit] <dtml-var id> has been submitted for review.',
                                        submit_message,
                                    ),
                'notify_deny':      (
                                        'Notify on deny',
                                        '[Notify Deny] <dtml-var id> has been denied for publishing.',
                                        deny_message,
                                    ),
                'notify_publish':   (
                                        'Notify on publish',
                                        '[Notify Publish] <dtml-var id> has been published.',
                                        publish_message,
                                    ),
                'notify_revoke':   (
                                        'Notify on revoke',
                                        '[Notify Revoke] <dtml-var id> has been revoked from publishing.',
                                        revoke_message,
                                   ),
                'notify_retract':    (
                                        'Notify on retract',
                                        '[Notify Retraction] <dtml-var id> has been retracted from submittion.',
                                        retract_message,
                                    ),

                'notify_delegate':    (
                                        'Notify on delegate',
                                        '[Notify Delegation] You have been assigned as an Author for <dtml-var id>.',
                                        delegate_message,
                                    ),
#Sync notification
                'notify_master_changed':    (
                                        'Notify on master changed',
                                        '[Notify Master Publish] the master object for <dtml-var id> has changed.',
                                        master_publish_message,
                                    ),



           }
                #'notify_archive':   ('Notify on archive',)
                #'notify_accept':    ('Notify on accept',),

send_error_message = HTML("""\
<dtml-var error_message>

NOTIFICATION MESSAGE NOT SENT:

From: <dtml-var from_addr>
To: <dtml-var to_addr>
Subject: <dtml-var subject>

<dtml-var message>
""")
