# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyPresentationHelpers/DTMLCheckboxList.py,v 1.1 2004/06/28 10:05:47 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__='''DTMLCheckboxList
$Id: DTMLCheckboxList.py,v 1.1 2004/06/28 10:05:47 johanc Exp $'''
__version__='$Revision: 1.1 $'[11:-2]

import string
from DocumentTemplate.DT_Util   import *
from DocumentTemplate.DT_String import String
from DocumentTemplate.DT_Util import render_blocks
from types import ListType, StringType, TupleType
SeqvenceType = (ListType,TupleType)

from Products.EasyCore.TagUtils import SingleTagBase, HTML, STRING_PARAM, SILENT_PARAM, strip_html
from Globals import DTMLFile
from Products.EasyCore import MLOG_TAB


_marker=[]

class DTMLCheckboxList(SingleTagBase):
    """\
    DTMLCheckboxList Tag

    Serves a checkbox list with Link Group awareness
    The layout is a table which can be modified by:
      - Orientation
      - Width
      - Apperance:
         o border,
         o cellpadding and, cellspacing,
         o css classes and styles

    """

    name='checkboxlist'
    expr=None
    persist=('default_active',)
    attributes={
          'id':             {'value':'', 'required':1,'type':STRING_PARAM},
          'header_title':   {'value':'', 'required':0,'type':STRING_PARAM},
          'width':          {'value':'', 'required':0,'type':STRING_PARAM},
          'intendwidth':    {'value':'', 'required':0,'type':STRING_PARAM},
          'table_align':    {'value':'', 'required':0,'type':STRING_PARAM},
          'table_class':    {'value':'', 'required':0,'type':STRING_PARAM},

          'header_class':   {'value':'list-header', 'required':1,'type':STRING_PARAM},

          'checkbox_class': {'value':'', 'required':0,'type':STRING_PARAM},
          'label_class':    {'value':'tab-small', 'required':1,'type':STRING_PARAM},

          'table_style':    {'value':'', 'required':0,'type':STRING_PARAM},
          'checkbox_style': {'value':'', 'required':0,'type':STRING_PARAM},
          'label_style':    {'value':'', 'required':0,'type':STRING_PARAM},
          'onClick':        {'value':'', 'required':0,'type':STRING_PARAM},
          'onSelect':       {'value':'', 'required':0,'type':STRING_PARAM},
          'hiddendefault':  {'value':'', 'required':0,'type':STRING_PARAM},

          'default_active': {'value':('method',),   'required':0,   'type':SILENT_PARAM},
          'items':          {'value':(('method','Method'),('menu','Menu')), 'required':0,   'type':SILENT_PARAM},

          'usekeyasname':   {'value':'',    'required':0,'type':STRING_PARAM},
          'border':         {'value':0,     'required':1,'type':STRING_PARAM},
          'cellspacing':    {'value':0,     'required':1,'type':STRING_PARAM},
          'cellpadding':    {'value':0,     'required':1,'type':STRING_PARAM},
          'header_style':   {'value':'padding:1px 5px 1px 0px;',    'required':1,'type':STRING_PARAM},
    }



    _dtmlCheckboxListVerticalDTML = HTML("""\
           <dtml-table
               border:exec="border"
               cellspacing:exec="cellspacing"
               cellpadding:exec="cellpadding"
               class:exec="table_class"
               style:exec="table_style"
               align:exec="table_align"
               id:exec="elementid"
               width:exec="width"
           >
             <dtml-tr condition="header_title">
               <dtml-td width="20"></dtml-td>
               <dtml-td style:exec="header_style" class:exec="header_class"><dtml-var header_title></dtml-td>
             </dtml-tr>
             <dtml-in items prefix="item">
               <dtml-tr>
                 <dtml-td style:exec="checkbox_style" class:exec="checkbox_class">
                    <dtml-checkbox
                        id:exec="item_key" value:exec="item_item"
                        active:exec="item_key"
                        persist:exec="item_key"
                    />
                  </dtml-td>
                 <dtml-td style:exec="label_style" class:exec="label_class"><dtml-var item_key><dtml-var item_item></dtml-td>
               </dtml-tr>
             </dtml-in items>
           </dtml-table>

       """, globals())



    def do_render(self, md, object):
        #for key, value in self.items:
        #default_active
        return string.strip(self._dtmlCheckboxListVerticalDTML(client=self, REQUEST=md))



String.commands[DTMLCheckboxList.name] = DTMLCheckboxList



