# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/EasyWorkflow/EasyRegionDiff.py,v 1.2 2004/09/09 13:25:46 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""EasyPublishSync mixin class"""
__version__='$Revision: 1.2 $'[11:-2]

import Globals
from Acquisition import Implicit, aq_base, aq_get
from types import DictType, TupleType, ListType, StringType
from Products.EasyCore.VirtualPathHelpers import path2url, url2path, comparePaths

from ComputedAttribute import ComputedAttribute

NOTINITED=[]

class RegionInfo:

    id=''
    storagecontainerid=NOTINITED
    #region=NOTINITED
    value=NOTINITED

    def __init__(self, id='', region=None, object=None):
        self.id=id
        if region is not None:
            self.storagecontainerid=region.storagecontainerid
            self.region=region
            if object is not None:
                value=getattr(object, region.storagecontainerid, None)
                #No REQUEST!!!!
                #if value is None: region.initcontent(object, REQUEST=REQUEST)
                if value is not None:
                    #TODO: Need to use a compare method in Region or Storage to diff different storages
                    self.value=value.document_src()
                else: self.value=None

    def getValue(self):
        if self.value is NOTINITED: return 'Not syncronized.'
        return self.value or 'Region Storage Missing'

    def getStorageId(self):
        return self.storagecontainerid

    def getStorageType(self):
        return self.region.storage

    def exists(self):
        return self.value is not None

    #def manage_compare(self, editablecontainer, obj):
    #    return self.region.manage_copy(editablecontainer, obj)

    #def manage_copy(self, editablecontainer, parent):
    #    region.manage_copy(editablecontainer, parent)


MISSINGREGIONINFO=RegionInfo()

class RegionDiff(Implicit):
    """\
    PropertyregionDiff is the result of an Diff operation.

    PropertyregionDiff takes three arguments at initiation:
        local, remote, old_remote, which are ObjectInfo instances

    """

    __allow_access_to_unprotected_subobjects__=1

    id=''
    remote=None
    old_remote=None
    local=None

    def __init__(self
                , id, local, remote, old_remote, local_obj=None , remote_obj=None
                , ignore = ('creation_date','contributors','language')
            ):
        self.id=id
        self.local =local
        self.remote=remote
        self.old_remote=old_remote

    def getId(self):
        return self.id

    def getLabel(self):
        return self.id

    def _isDifferent(self):
        remote_value=self.remote.getValue()
        old_remote_value=self.old_remote.getValue()
        if remote_value==old_remote_value: return 0
        return 1
    isDifferent=ComputedAttribute(_isDifferent, 0)

    def getDiff(self):
        return self.remote.getValue()

    def getOldRemoteRegion(self):
        return self.old_remote.getValue()

    def getNewRemoteRegion(self):
        return self.remote.getValue()


    def getStorageType(self):
        return self.remote.getStorageType()

    def existsLocally(self):
        exists=getattr(self.local,'exists', 0)
        if callable(exists): exists=exists()
        return exists

    def existsRemotely(self):
        exists=getattr(self.remote,'exists', 0)
        if callable(exists): exists=exists()
        return exists


