#####
###  MailBoxer - a mailinglist/newsletter/mailarchive-framework for ZOPE
##   Copyright (C) 2003	Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####

MailBoxerTemplates={}

MailBoxerTemplates['mail_header'] = r"""
<dtml-comment>
 Additional headers for mailinglists which will be added to the bulked
 mails. Don't delete the X-Mailer. It's important to avoid endless mail-loops.
</dtml-comment>

Content-type: <dtml-var "mail.get('content-type','text/plain')">
Subject: <dtml-if "mime_decode_header(mail.get('subject','')).find('[%s]' % getValueFor('title'))==-1">[<dtml-var "getValueFor('title')">] </dtml-if><dtml-var "mail.get('subject','No Subject')">
Message-id: <dtml-var "uniqueMessageId()">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Reply-To: <dtml-var "getValueFor('mailto')">
Errors-To: <dtml-var "getValueFor('returnpath')">
List-Post: <mailto:<dtml-var "getValueFor('mailto')">>
List-Subscribe: <mailto:<dtml-var "getValueFor('mailto')">?subject=<dtml-var "getValueFor('subscribe')">>
List-Unsubscribe: <mailto:<dtml-var "getValueFor('mailto')">?subject=<dtml-var "getValueFor('unsubscribe')">>
List-Id: <dtml-var "getValueFor('title')">
Precedence: Bulk
"""

MailBoxerTemplates['mail_footer'] = r"""
<dtml-comment>
 Footer for plain-text-mails which will be added to the bulked mails.
 Remove dtml-comment in last line to show a link to archived mail.
</dtml-comment>
-- 
To unsubscribe send an email with subject <dtml-var "getValueFor('unsubscribe')"> to <dtml-var "getValueFor('mailto')">.
Please contact <dtml-var "getValueFor('moderator')[0]"> for questions.
<dtml-comment><dtml-var absolute_url></dtml-comment>
"""

MailBoxerTemplates['mail_subscribe'] = r"""
<dtml-comment> 
 This scripts handles the subscribe-request.
</dtml-comment>

<dtml-if "mime_decode_header(mail.get('subject','')).find(pin(mail.get('from','')))==-1">

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail.get('from')">
From: <dtml-var "getValueFor('mailto')">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Subject: <dtml-var "getValueFor('subscribe')"> [<dtml-var "pin(mail.get('from'))">]

Hello <dtml-var "mime_decode_header(mail.get('from'))">,

We have received a subscription request for your email address to the
<dtml-var "getValueFor('title')"> mailing list. To confirm the request,
simply reply to this message, leaving the subject line unchanged.

If you do not wish to subscribe to this list, please disregard this
message.  Send questions to <dtml-var "getValueFor('moderator')[0]">. 

Yours, <dtml-var "getValueFor('moderator')[0]">
</dtml-sendmail>

<dtml-else>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail.get('from')">
From: <dtml-var "getValueFor('mailto')">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Subject: Welcome to [<dtml-var "getValueFor('title')">]

Hello <dtml-var "mime_decode_header(mail.get('from'))">,

you are now subscribed to <dtml-var "getValueFor('title')">.

Send your mails to: <dtml-var "getValueFor('mailto')">

If you want to unsubscribe from <dtml-var "getValueFor('title')">,
send a mail with subject (not body!):

<dtml-var "getValueFor('unsubscribe')"> 

to: <dtml-var "getValueFor('mailto')">

Yours, <dtml-var "getValueFor('moderator')[0]">
</dtml-sendmail>

</dtml-if>
"""

MailBoxerTemplates['mail_unsubscribe'] = r"""
<dtml-comment>
 This scripts handles unsubscribe-requests.
</dtml-comment>

<dtml-if "mime_decode_header(mail.get('subject')).find(pin(mail.get('from')))==-1">

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail.get('from')">
From: <dtml-var "getValueFor('mailto')">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Subject: <dtml-var "getValueFor('unsubscribe')"> [<dtml-var "pin(mail.get('from'))">]

Hello <dtml-var "mime_decode_header(mail.get('from'))">,

we have received a request to unsubscribe your email address from the
<dtml-var "getValueFor('title')"> mailing list.

To confirm the request, simply reply to
this message, leaving the subject line unchanged.

If you do not wish to cancel your subscription, please disregard this
message.  Send questions to <dtml-var "getValueFor('moderator')[0]">.

Yours, <dtml-var "getValueFor('moderator')[0]">
</dtml-sendmail>

<dtml-else>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail.get('from')">
From: <dtml-var "getValueFor('moderator')[0]">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Subject: Unsubscribed from [<dtml-var "getValueFor('title')">]

You have been unsubscribed from <dtml-var "getValueFor('title')">.

Farewell!

Yours, <dtml-var "getValueFor('moderator')[0]">
</dtml-sendmail>
</dtml-if>
"""

MailBoxerTemplates['mail_reply'] = r"""
<dtml-comment>
 This script sends an 'error' reply to the sender.
</dtml-comment>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail.get('from')">
From: <dtml-var "getValueFor('moderator')[0]">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Subject: [<dtml-var "getValueFor('title')">] Mail unprocessed

Your email with the subject

 <dtml-var "mime_decode_header(mail.get('subject','No subject'))">

could not be processed for the address

 <dtml-var "parseaddr(mail.get('from'))[1]">

for the mailinglist

 <dtml-var "getValueFor('title')">.

Possible reason:

<dtml-if "parseaddr(mail.get('from'))[1].lower() in lowerList(getValueFor('maillist'))">
 - You tried to subscribe with a already subscribed address.
<dtml-else>
 - You are not subscribed to this list with the above address.
</dtml-if>

Yours, <dtml-var "getValueFor('moderator')[0]">
</dtml-sendmail>
"""

MailBoxerTemplates['mail_approve'] = r"""
<dtml-comment>
 This view is called when a moderation request for a queued mail arrives.
</dtml-comment>

<dtml-var standard_html_header>

<h1><dtml-var "getValueFor('title')"> (<dtml-var "getValueFor('mailto')">)</h1>

<dtml-if "msg!='INVALID_REQUEST'">
 <dtml-in "restrictedTraverse(getValueFor('mailqueue')).objectValues()">
  <dtml-if sequence-start>
   <h3>Pending requests</h3>
   <ul>
  </dtml-if>
  <li>
   <a href="<dtml-var "absolute_url()">"><dtml-var title></a>
   <dtml-in "['approve','discard']">
    [<a href="<dtml-var URL>?action=<dtml-var sequence-item>&mid=<dtml-var getId>&pin=<dtml-var "pin(getValueFor('mailto'))">"><dtml-var sequence-item></a>]
   </dtml-in>
  </li>
  <dtml-if sequence-end>
   </ul>
  </dtml-if>
 <dtml-else>
  <h3>No pending requests</h3>
 </dtml-in>
<dtml-else>
 <h2>Invalid Request!</h2>
 <p>The url you submitted could not be resolved! Please check if it wasn't truncated.</p>
</dtml-if>

<dtml-if "msg=='MAIL_NOT_FOUND'">
 <h2>Mail not found!</h2>
 <p>Maybe the message was already processed by another moderator.</p>
</dtml-if>

<dtml-if "msg=='MAIL_APPROVE'">
 <h2>Mail approved!</h2>
 <p>The following mail was sent to the list:</p>
 <hr />
 <pre><dtml-var "getMailFromRequest(REQUEST)"></pre>
 <hr />
</dtml-if>

<dtml-if "msg=='MAIL_DISCARD'">
 <h2>Mail discarded!</h2>
 <p>The following mail was deleted from queue:</p>
 <hr />
 <pre><dtml-var "getMailFromRequest(REQUEST)"></pre>
 <hr />
</dtml-if>

<dtml-var standard_html_footer>
"""

MailBoxerTemplates['mail_moderator'] = r"""
<dtml-comment>
 This script sends a moderation-request to the moderators
 and a notification to the sender.
</dtml-comment>

<dtml-let boundary="'Boundary-%s-%s' % (ZopeTime().millis(), _.random.random())">
<dtml-sendmail mailhost="MailHost">
To: <dtml-var "','.join(getValueFor('moderator'))">
Subject: [<dtml-var "getValueFor('title')"> - MODERATE] <dtml-var "mail.get('subject','No subject')">
From: <dtml-var "mail.get('from')">
X-Mailer: <dtml-var "getValueFor('xmailer')">
Mime-Version: 1.0
Content-Type: multipart/mixed; boundary="<dtml-var boundary>"

--<dtml-var boundary>
Content-Type: text/plain
Content-Transfer-Encoding: 8bit

We have received a moderation request for the mailinglist <dtml-var "getValueFor('title')">.

If you want to approve the attached mail, please visit the following url:

<dtml-var absolute_url>/manage_moderateMail?action=approve&mid=<dtml-var mid>&pin=<dtml-var "pin(getValueFor('mailto'))">

If you want to discard the attached mail, please visit the following url:

<dtml-var absolute_url>/manage_moderateMail?action=discard&mid=<dtml-var mid>&pin=<dtml-var "pin(getValueFor('mailto'))">

--<dtml-var boundary>
Content-Type: message/rfc822; name="forwarded message"
Content-Description: <dtml-var "mail.get('from')">: <dtml-var "mail.get('subject')">

<dtml-var "getMailFromRequest(REQUEST)">
--<dtml-var boundary>--
</dtml-sendmail>
</dtml-let>

<dtml-sendmail mailhost="MailHost">
To: <dtml-var "mail.get('from')">
From: <dtml-var "getValueFor('moderator')[0]">
Subject: [RECEIVED] <dtml-var "mail.get('subject', 'No subject')">
X-Mailer: <dtml-var "getValueFor('xmailer')">

Your mail has been received, and is awaiting approval by a moderator.
Once approved, it will show up on the list.

Yours, <dtml-var "getValueFor('moderator')[0]">
</dtml-sendmail>
"""

MailBoxerTemplates['index_html'] = r"""
<dtml-var standard_html_header>
<dtml-if query>
 <dtml-var mail_search>
<dtml-else>
 <dtml-var mail_index>
</dtml-if>
<dtml-var standard_html_footer>
"""

MailBoxerTemplates['mail_index'] = r"""
<dtml-if "this().aq_parent.hasProperty('mailDate')">
 <dtml-return "RESPONSE.redirect(this().aq_parent.absolute_url())">
</dtml-if>
 
<table width="100%" cellspacing="0" cellpadding="4">
<tr>
<td valign="top">

 <p>
 <small>
 <dtml-in PARENTS reverse>
 <dtml-if title>
  / <a href="<dtml-var absolute_url>">
     <dtml-var "_.test(hasProperty('mailSubject'), 
                              getProperty('mailSubject'), title)" html_quote>
    </a>
 </dtml-if title>
 </dtml-in PARENTS>
 </small>
 </p>

 <dtml-let previousObject="previousObject(this())"
              nextObject="nextObject(this())">

 <form action="<dtml-var URL>">
  <dtml-if previousObject>
   [ <a href="<dtml-var "previousObject.absolute_url()">">&lt;&lt;</a> ]
  </dtml-if>

  <dtml-if nextObject>
   [ <a href="<dtml-var "nextObject.absolute_url()">">&gt;&gt;</a> ]
  </dtml-if>

  <input type="text" name="query"> <input type="submit" value=" Search ">
 </form>
 
 <p>
 <small>
  <dtml-if previousObject>
   [ <a href="<dtml-var "previousObject.absolute_url()">">
     <dtml-var "at(previousObject.title)" html_quote size=50></a> ]
  </dtml-if>

  <dtml-if nextObject>
   [ <a href="<dtml-var "nextObject.absolute_url()">">
     <dtml-var "at(nextObject.title)" html_quote size=50></a> ]
  </dtml-if>
 </small>
 </p>

 </dtml-let>

 <dtml-if mailDate>

  <dtml-var mail_template>
  <dtml-in "archiveFolders(this())" sort=id>
   <dtml-var mail_template>
  </dtml-in>

 <dtml-else>

  <dtml-in "archiveFolders(this())" sort=id reverse>

   <dtml-if sequence-start><ul></dtml-if>

   <li>
    <dtml-if mailDate>
     <b>
         <dtml-var "mailDate.ISO()">
         <a href="<dtml-var absolute_url>#<dtml-var getId>">
          <dtml-var mailSubject html_quote null="No subject">
         </a>

         <dtml-if "not aq_parent.hasProperty('mailDate')"> 
          / <dtml-var "at(mailFrom)" html_quote>
         </dtml-if>
     </b>

     <br>
     <small><dtml-var "at(mailBody[:200])" html_quote>...</small>
     <br>
     <br>

     <dtml-else>
       <b><a href="&dtml-absolute_url;"><dtml-var "at(title)" html_quote></a></b>
    </dtml-if mailDate>
   </li>

    <dtml-in "archiveFolders(_['sequence-item'])" sort=id reverse>

     <dtml-if sequence-start><ul></dtml-if>

     <li>
     <dtml-if mailDate>
        <dtml-if "not aq_parent.hasProperty('mailDate')">
         <dtml-var "mailDate.Date()">
        <dtml-else>
         <dtml-var "mailDate.ISO()">
        </dtml-if> 
        
        <a href="<dtml-var absolute_url>#<dtml-var getId>">
         <dtml-if "aq_parent.hasProperty('mailDate')">
           <dtml-var "at(mailFrom)" html_quote null="No sender">
         <dtml-else>
           <dtml-var mailSubject html_quote null="No subject">
         </dtml-if>
        </a>
        
        <dtml-let follow="_.len(archiveFolders(_['sequence-item']))">
         <dtml-if follow> [<dtml-var follow>]</dtml-if>
        </dtml-let>
 
     <dtml-else>
       <a href="&dtml-absolute_url;"><dtml-var "at(title)" html_quote></a>
     </dtml-if mailDate>

    </li>
    <dtml-if sequence-end></ul><br></dtml-if>
   </dtml-in>

   <dtml-if sequence-end></ul><br></dtml-if>

   </dtml-in>

</dtml-if>
</td>

 <dtml-if "meta_type=='Mail Boxer'">
  <td valign="top">

  <h3>Recent Posts</h3>

   <dtml-let mbCatalog="restrictedTraverse(getValueFor('catalog'))">

    <dtml-in "mbCatalog.searchResults(mailDate={'query':_.DateTime()-7,'range':'min'},
                                                 sort_on='mailDate')" size=10 reverse>

    <dtml-if sequence-start><ul></dtml-if sequence-start>

    <dtml-with "mbCatalog.getobject(data_record_id_)">

      <li>
       <b><dtml-var "mailDate.ISO()"></b>
       <a href="<dtml-var absolute_url>#<dtml-var getId>">
        <b><dtml-var mailSubject null="No subject" html_quote></b>
       </a>
        / <dtml-var "at(mailFrom)" html_quote>
       <br />
       <small><dtml-var "at(mailBody[:200])" html_quote></small>
       <br />
       <br />
      </li>
     </dtml-with>

     <dtml-if sequence-end></ul></dtml-if>

     <dtml-else>
        Sorry, but there are no recent posts...
  </dtml-in>
  </dtml-let>

  </td>
 </dtml-if>

</tr>
</table>

<a href="http://www.zope.org/Members/mjablonski/MailBoxer/">
 <img src="/misc_/MailBoxer/mailboxer.png" border="0" alt="MailBoxer" title="MailBoxer" align="right">
</a>
"""

MailBoxerTemplates['mail_template'] = r"""
<dtml-comment> This is the template for rendering an archived mail </dtml-comment>

<a name="<dtml-var getId>">

 <table width="100%" bgcolor="#e0e0e0">
 <tr>
  <td valign="top" width="60%"><b><dtml-var mailSubject html_quote></b>
     <br><dtml-var "at(mailFrom)" html_quote></td>
  <td valign="top" width="20%"><b><dtml-var "mailDate.ISO()"></b></td>
  <td valign="top" width="20%" align="right">

   <dtml-if fullMode>
   [ <a href="<dtml-var URL>#<dtml-var getId>">SNIP</a> ]
  <dtml-else>
   [ <a href="<dtml-var URL>?fullMode=1#<dtml-var getId>">FULL</a> ]
  </dtml-if> 
  </td> 
 </tr>
 </table>

</a>

 <table width="100%">
 <tr>
  <td>
   <dtml-if fullMode>
    <pre><dtml-var "textwrap(at(mailBody),79)" html_quote></pre>
   <dtml-else>
    <pre><dtml-var "textwrap(snipMail(at(mailBody)),79)"></pre>
   </dtml-if>
  </td>
 </tr>

 <dtml-let attachments="objectValues('File')">
 <dtml-if attachments>
  <tr>
   <td>
   <table>
    <tr>
      <td><b>Attachments:</b></td><td>&nbsp;</td><td>&nbsp;</td>
    </tr>
    
    <dtml-in attachments>
     <tr>
      <td><a href="<dtml-var absolute_url>/download"><dtml-var title_or_id></a></td>
      <td><dtml-var content_type missing="application/x-unknown-content-type"></td>
      <td><dtml-var size missing="?"> Bytes</td>
     </tr>
    </dtml-in>
   </table>
   </td>
  </tr>
 </dtml-if>
 </dtml-let>
 </table>

<hr noshade>
"""

MailBoxerTemplates['mail_search'] = r"""
 <p>
 <small>
 <dtml-in PARENTS reverse>
 <dtml-if title>
  / <a href="<dtml-var absolute_url>">
     <dtml-var "_.test(hasProperty('mailSubject'), 
                              getProperty('mailSubject'), title)" html_quote>
    </a>
 </dtml-if title>
 </dtml-in PARENTS>
 </small>
 </p>

<form action="<dtml-var URL>" method="get">
 Search: <input name="query" width=30 value="<dtml-var query missing>">
 <input type="submit" value=" Search ">
</form>

<dtml-if query>

 <dtml-in "searchMailBoxerArchive(query)" size=10 start=query_start>
 
  <dtml-if sequence-start>
   <dtml-if previous-sequence-start-number>
    <a href="<dtml-var URL><dtml-var sequence-query>query_start=<dtml-var
         previous-sequence-start-number>"><b>[&lt;&lt;&lt; ]</b></a>
   </dtml-if previous-sequence-start-number>

   &nbsp;<b><dtml-var sequence-length> hits</b>&nbsp;

   <dtml-if next-sequence-start-number>
    <a href="<dtml-var URL><dtml-var sequence-query>query_start=<dtml-var
        next-sequence-start-number>"><b>[ &gt;&gt;&gt;]</b></a>
   </dtml-if next-sequence-start-number>
   
   <table width="100%" cellspacing="0" cellpadding="4">
   <tr>
    <th>Nr.</th><th>Date</th><th>Subject</th><th>From</th>
   </tr>
  </dtml-if sequence-start>

 <dtml-if sequence-even><tr bgcolor="#e0e0e0"><dtml-else><tr></dtml-if>

  <td><dtml-var sequence-number></td>
  <td><dtml-var "mailDate.ISO()"></td>
  <td><a href="<dtml-var absolute_url>#<dtml-var getId>">
         <b><dtml-var mailSubject null="No subject" html_quote></b>
        </a>
        <br>
        <small><dtml-var "at(mailBody[:200])" html_quote></small></td>
  <td><dtml-var "at(mailFrom)" html_quote></td>
  </tr>

 <dtml-if sequence-end></table></dtml-if>

 <dtml-else>
   There was no data matching this query.
 </dtml-in>

</dtml-if query>
"""

MailBoxerTemplates['download'] = r"""Content-Type: <dtml-var content_type missing="application/x-unknown-content-type">
Content-Disposition: Attachment; Filename=<dtml-var title_or_id>

<dtml-var this>"""
