# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/Products/ObjectRepository/PatchPluginIndex.py,v 1.1 2004/06/28 10:07:06 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#



from Products.ZCatalog.Lazy import LazyMap
from BTrees.IIBTree import intersection, IISet
from types import IntType


from Products.PluginIndexes.FieldIndex.FieldIndex import FieldIndex
from Products.PluginIndexes.TextIndex.TextIndex import TextIndex
from Products.PluginIndexes.DateIndex.DateIndex import DateIndex
from Products.PluginIndexes.DateRangeIndex.DateRangeIndex import DateRangeIndex
from Products.PluginIndexes.TopicIndex.TopicIndex import TopicIndex
from Products.PluginIndexes.KeywordIndex.KeywordIndex import KeywordIndex
from Products.PluginIndexes.PathIndex.PathIndex import PathIndex


def lazy_group_by(self, id, rs):
    """\
    returns the a lazy map of the intersection of the recordset (rs)
    and the set of document matchin each unique value

    if withLengths is true, returns a sequence of
    tuples of (value, length)
    """

    def group(id, index=self._index, rs=rs):
        set=index[id]
        if type(set) is IntType:  set=IISet((set,))
        return intersection(rs, set)
    return LazyMap(group, self._index.keys(), len(self._index))


FieldIndex.group_by=lazy_group_by
#TextIndex.group_by=lazy_group_by
DateIndex.group_by=lazy_group_by
#DateRangeIndex.group_by=lazy_group_by
#KeywordIndex.group_by=lazy_group_by
#PathIndex.group_by=lazy_group_by
#TopicIndex.group_by=lazy_group_by
##FieldIndex.group_by=lazy_group_by
##FieldIndex.group_by=lazy_group_by
##FieldIndex.group_by=lazy_group_by
