

from Globals import DTMLFile
from types import ListType
from AccessControl.Role import RoleManager
from AccessControl.Permission import Permission

def permission_settings(self):
    """Return user-role permission settings
    """
    result=[]
    valid=self.valid_roles()
    indexes=range(len(valid))
    ip=0
    for p in self.ac_inherited_permissions(1):
        name, value = p[:2]
        aq_roles = len(p)>2 and p[2] or ()
        p=Permission(name,value,self)
        roles=p.getRoles(default=[])
        d={'name': name,
           'acquire': type(roles) is ListType and 'CHECKED' or '',
           'roles': map(
               lambda ir, roles=roles, valid=valid, ip=ip, aq_roles=aq_roles:
               {
                   'name': "p%dr%d" % (ip,ir),
                   'checked': (valid[ir] in roles) and 'CHECKED' or '',
                   'is_acquired': valid[ir] in aq_roles,
                   },
               indexes)
           }
        ip=ip+1
        result.append(d)
    return result

def manage_changePermissions(self, REQUEST):
    "Change all permissions settings, called by management screen"
    self._isBeingUsedAsAMethod(REQUEST, 0)
    valid_roles=self.valid_roles()
    indexes=range(len(valid_roles))
    have=REQUEST.has_key
    permissions=self.ac_inherited_permissions(1)
    fails = []
    for ip in range(len(permissions)):
        roles=[]
        for ir in indexes:
            if have("p%dr%d" % (ip,ir)): roles.append(valid_roles[ir])
        name, value = permissions[ip][:2]
        try:
            p=Permission(name,value,self)
            if not have('a%d' % ip): roles=tuple(roles)
            p.setRoles(roles)
        except:
            fails.append(name)

    if fails:
        return MessageDialog(title="Warning!",
                             message="Some permissions had errors: "
                               + escape(', '.join(fails)),
                             action='manage_access')
    return self.manage_access(REQUEST, manage_tabs_message='Your changes have been saved')


RoleManager.permission_settings = permission_settings
RoleManager.manage_changePermissions = manage_changePermissions