#!/usr/local/bin/python
#
# $Header: /usr/custom/cvs/public/CollibertyEasyPublisher/utils/StopZope.py,v 1.1 2004/09/09 13:25:46 johanc Exp $
#
# Copyright (C) 2001-2003, Johan Carlsson, Lennart Regebro, Colliberty.
# This software is licensed under the Easy Publisher Shared License 2.0 and/or
# the Easy Publisher Enterprise License 2.0 and/or the Easy Publisher Developers License 2.0
# and/or the Easy Publisher Personal Developers License 2.0.
# The licensee may not give, sell, sub-license, rent, lease, lend or in any other
# way distribute any portion of the Software or Documentation to anyone.
# For details about the licenses contact Colliberty at info@colliberty.com
#

#

__doc__="""
Stops Zope via the ZMI::Control Panel

Usage:
    StopZope.py
"""
__version__='$Revision: 1.1 $'[11:-2]

import sys
from urlparse import urlparse
from urllib import urlencode
from httplib import HTTPConnection, HTTPSConnection
from base64 import encodestring

url='http://localhost/Control_Panel/manage_shutdown'
username='****'
password='****'

default_args={'url':url,'u':username,'p':password}

def parseArgs(default={}):
    for arg in sys.argv[1:]:
        arg = arg.split('=')
        if len(arg)==2:
            key, value=arg
            key=key.strip().lower()
            value=value.strip()
            default[key]=value
        elif len(arg)==1:
            key=arg[0].strip().lower()
            default[key]=1
        elif len(arg)>2:
            key, value= arg[0], a[1:]
            key=key.strip().lower()
            value='='.join(value)
            default[key]=value
    return default



def get_authtoken(username,password, atype='Basic'):
    if atype=='Basic':
        authorization=(
            "Basic %s" % (encodestring('%s:%s' % (username,password))).replace('\012',''))
        return authorization
    raise ValueError, 'Unknown authentication scheme: %s' % atype


def StopZope(url, username=None, password=None, headers={}):
    """Send a request back to Zope"""

    scheme, host, path = urlparse(url)[:3]
    ssl = scheme == 'https'

    if ssl:
        h = HTTPSConnection(host)
    else:
        h = HTTPConnection(host)

    body=''

    h.putrequest('POST', path)
    h.putheader('User-Agent', 'StopZope/%s' % __version__)
    h.putheader('Connection', 'close')

    for header, value in headers.items():
        h.putheader(header, value)

    h.putheader("Content-Length", str(len(body)))


    if username is not None and password is not None:
        h.putheader("Authorization", get_authtoken(username,password))

    h.endheaders()
    h.send(body)
    return h.getresponse()



if __name__=='__main__':
    args=parseArgs(default_args)
    url=args.get('url',None)
    username=args.get('u',None)
    password=args.get('p',None)

    if url is not None:
        file=open('StopLog.log','a')
        r=StopZope(url,username=username, password=password)

        print "Status:   %i" % r.status
        print "Url:      %s" % url
        print "Username: %s" % username
        print "Password: %s" % ('*' * len(password),)
        file.write("=" *55)
        file.write("\n")
        file.write("Status:   %i\n" % r.status)
        file.write("Url:      %s\n" % url)
        file.write("Username: %s\n" % username)
        file.write("Password: %s\n" % ('*' * len(password),))
        file.write("-" *55)
        file.write("\n\n")

        if r.status==302:
            print "Script executed successfully"
            file.write("Script executed successfully\n")
            file.write("-" *55)
            file.write("\n\n")
            file.close()
            sys.exit(0)
        if r.status==500:
            print "No packing needed!"
            file.write("No packing needed!\n")
            file.write("-" *55)
            file.write("\n\n")
            file.close()
            sys.exit(3)
        if r.status==401:
            print "Unauthorized!"
            file.write("Unauthorized!\n")
            file.write("-" *55)
            file.write("\n\n")
            file.close()
            sys.exit(4)

        print "It probably worked?", r.status
        file.write("-" *55)
        file.write("\n\n")
        file.close()
        sys.exit(0)

    print "Invalid URL"
    file.close()
    sys.exit(1)
